/**
 * BImage
 *
 */

/*global tinymce:true */

tinymce.PluginManager.add('BImage', function(editor, url){
	//添加命令
	editor.addCommand('BImageWin', function(ui, value) {
		// var _url = _alt = '';
		// if (typeof value == 'object') {
		// 	_url = value.url;
		// 	_alt = value.alt;
		// }
		var html = '<p class="row"><label>输入图片地址:　<input type="text" id="imgurl" size="50" value="" /></label>　';
		html += '<input type="button" class="button button-small" tabindex="-1" value="或上传" onclick="tinymce.execCommand(\'UploadImage\');" /></p>';
		html += '<p class="row"><label>填写图片描述:　<input type="text" id="imgalt" size="50" value="" /></label>　<span>(可不填)</span></p>';
		html += '<div class="tips">';
		html += 	'<p>1.支持网络图片和本地上传</p>';
		html += 	'<p>2.支持jpg和png静态图 也支持gif动态图</p>';
		html += 	'<p>3.如果检测到图片类型为gif会自动生成一张静态图片作为预览图</p>';
		html += 	'<p>4.这里只能插入单张图片 但你可以多次使用此工具 以插入多张单图</p>';
		html += 	'<p>5.图片描述是对SEO友好的 如果你不介意 可不填</p>';
		html += 	'<p style="color:#F00;">6.如果网络图片体积较大 需要耐心等待</p>';
		html += '</div>';
		html += '<div class="submitbox">';
		html += 	'<span class="spinner"></span>';
		html += 	'<input type="button" class="cancel button" tabindex="-1" value="取消" onclick="tinymce.activeEditor.windowManager.close();" />';
		html += 	'<input type="button" class="insert button button-primary" tabindex="-1" value="识别并插入" onclick="tinymce.execCommand(\'InsertBImage\');" />';
		html += '</div><br style="clear: both;" />';
		var win = editor.windowManager.open({
			title: "插入单图",
			layout: 'flex',
			padding: 10,
			spacing: 10,
			width: 570,
			height: 265,
			items: {
				type: "container",
				html: html,
				border: 1,
				id: 'insert_image',
				// style: 'text-align: center',
				// minWidth: tinymce.DOM.getViewPort().w - 600,
				// minHeight: tinymce.DOM.getViewPort().h - 300,
			},
			buttons: []
		});
	});

	editor.addCommand('InsertBImage', function() {
		var _url, _id, _alt, shortcode;
		var load = jQuery('#insert_image .spinner');
		var imgurl = jQuery("#imgurl");
		_url = jQuery.trim( imgurl.val() );
		_alt = jQuery.trim( jQuery("#imgalt").val() );
		if (_url == '') {
			imgurl.focus();
			return;
		}
		var args = tinymce.activeEditor.windowManager.getParams();
		if ( ! jQuery.isEmptyObject(args) && args.url == _url && args.mime != 'image/gif' ) {
			shortcode = '[bimage from="in" id="'+args.id+'" url="'+_url+'" thumb="" width="'+args.width+'" height="'+args.height+'" gif="0" alt="'+_alt+'"]';
			tinymce.execCommand('mceInsertContent', false, shortcode);
			tinymce.activeEditor.windowManager.close();
			return;
		}
		load.show('fast');
		_id = !jQuery.isEmptyObject(args) ? args.id : 0;	//媒体id
		jQuery.post(ajaxurl, {'action': 'blueria_img_handler', 'url': _url, 'id': _id}, function(result, stat) {
			load.hide();
			if ( 'success' != stat ) return false;
			if ( 0 == result ) return false;
			if ( '-1' == result ) { tinymce.activeEditor.windowManager.alert("图片格式有误!!!"); return false; }
			if ( '-2' == result ) { tinymce.activeEditor.windowManager.alert("Gif格式有误!!!"); return false; }
			if ( '-3' == result ) { tinymce.activeEditor.windowManager.alert("网络图片尺寸失败!!!"); return false; }
			if ( /^\[.*\]$/.test(result) ) {
				// var data = eval(result);
				shortcode = result.toString().replace(/alt=\"\"/, 'alt="'+_alt+'"');
				tinymce.execCommand('mceInsertContent', false, shortcode);
				tinymce.activeEditor.windowManager.close();
				return;
			}
			tinymce.activeEditor.windowManager.alert("错误: "+result);
		});
	});

	editor.addCommand('UploadImage', function(ui, value) {
		var frame = wp.media();
		frame.on( "select", function() {
			var attachment = frame.state().get("selection").first().attributes;
			// console.log(attachment);	//==========================================================
			var _width = attachment.width;
			var _mime = attachment.mime;
			var _id = attachment.id;
			if (_width > 500 && _mime != "image/gif") {	//如果原图宽度>500 并且不是gif图
				var _url = attachment.sizes.large.url;	//large尺寸(宽500)
				var _height = attachment.sizes.large.height;
				_width = attachment.sizes.large.width;
			} else {
				var _url = attachment.url;
				var _height = attachment.height;
			}
			var _thumb = (_width > 160) ? attachment.sizes.thumbnail.url : '';	//宽度>160才有缩略图数据
			tinymce.activeEditor.windowManager.setParams({
				'width': _width,
				'height': _height,
				'mime': _mime,
				'url': _url,
				'thumb': _thumb,
				'id': _id,
			});
			frame.close();
			jQuery("#imgurl").val(_url);
			jQuery("#imgalt").focus();
		});
		frame.open();
	});

	//参见wp-includes\js\tinymce\plugins\wpeditimage\plugin.js line-955
	// editor.on( 'BeforeSetContent', function( event ) {
	// 	event.content = editor.wpSetImgCaption( event.content );
	// });

	// editor.on( 'PostProcess', function( event ) {
	// 	if ( event.get ) {
	// 		event.content = editor.wpGetImgCaption( event.content );
	// 		event.content = event.content.replace( / data-wp-imgselect="1"/g, '' );
	// 	}
	// });

	//添加按钮
	editor.addButton('BImage', {
		title : '插入图片',
		tooltip: '插入单图',
		cmd : 'BImageWin',
		image: url + "/image.png",
	});

	//添加到编辑器菜单
	// editor.addMenuItem('BImage', {
	// 	text: '插入单图',
	// 	icon: 'image',
	// 	cmd: 'BImageWin',
	// 	context: 'insert'
	// });
});