/* global tinymce, MediaElementPlayer, WPPlaylistView */
/**
 * Note: this API is "experimental" meaning that it will probably change
 * in the next few releases based on feedback from 3.9.0.
 * If you decide to use it, please follow the development closely.
 */

// Ensure the global `wp` object exists.
window.wp = window.wp || {};

jQuery(function($){
	var media = wp.media;

	wp.mce = wp.mce || {};

	wp.mce.bvideo = {
		shortcode: 'bvideo',
		toView:  function( content ) {
			var match = wp.shortcode.next( this.shortcode, content );

			if ( ! match ) {
				return;
			}

			return {
				index:   match.index,
				content: match.content,
				options: {
					shortcode: match.shortcode
				}
			};
		},

		View: {
			// className: 'editor-bvideo',
			template:  media.template('editor-bvideo'),

			postID: $('#post_ID').val(),

			initialize: function( options ) {
				this.shortcode = options.shortcode;
			},

			getHtml: function() {
				var attrs = this.shortcode.attrs.named,
					content = this.shortcode.content,
					options;

				options = {
					content: content,
					attr: attrs
				};

				return this.template( options );

			}
		},
		
		edit: function( node ) {
			// console.log(node);
			// console.log(this);
			var text = window.decodeURIComponent( $( node ).attr('data-wpview-text') );
			var shortcodeObj = wp.shortcode.next( this.shortcode, text );
			var url = shortcodeObj.shortcode.get('url');
			tinymce.execCommand('BVideoWin', 0, {'url':url, 'node':node, 'view':this});	//为了更新结果 我必须传一些必须的数据给frame
		}
	};
	wp.mce.views.register( 'bvideo', wp.mce.bvideo );

	// wp.media.bimage = new wp.media.collection({
	// 	tag: 'bimage',
	// 	type : 'image',
	// 	editTitle : "编辑相册",
	// 	defaults : {
	// 		itemtag: 'dl',
	// 		icontag: 'dt',
	// 		captiontag: 'dd',
	// 		columns: '3',
	// 		link: 'post',
	// 		size: 'thumbnail',
	// 		order: 'ASC',
	// 		id: wp.media.view.settings.post && wp.media.view.settings.post.id,
	// 		orderby : 'menu_order ID'
	// 	}
	// });
	wp.mce.bimage = {
		shortcode: 'bimage',
		toView:  function( content ) {
			var match = wp.shortcode.next( this.shortcode, content );

			if ( ! match ) {
				return;
			}

			return {
				index:   match.index,
				content: match.content,
				options: {
					shortcode: match.shortcode
				}
			};
		},

		View: {
			// className: 'editor-bimage',
			template:  media.template('editor-bimage'),

			postID: $('#post_ID').val(),

			initialize: function( options ) {
				this.shortcode = options.shortcode;
			},

			getHtml: function() {
				var attrs = this.shortcode.attrs.named,
					content = this.shortcode.content,
					options;

				options = {
					content: content,
					attr: attrs
				};

				return this.template( options );

			}
		},
		
		// edit: function( node ) {
		// 	var text = window.decodeURIComponent( $( node ).attr('data-wpview-text') );
		// 	var shortcodeObj = wp.shortcode.next( this.shortcode, text );
		// 	var url = shortcodeObj.shortcode.get('url');
		// 	var alt = shortcodeObj.shortcode.get('alt');
		// 	tinymce.execCommand('BImageWin', 0, {'url':url, 'alt':alt, 'node':node, 'view':this});
		// }

	};
	wp.mce.views.register( 'bimage', wp.mce.bimage );


});
