<?php
/*
 *	通用型功能函数(单独放置 方便管理)
 */


//禁止用户编辑主题
add_action('admin_menu', 'blueria_remove_editor_menu', 1);
function blueria_remove_editor_menu() {
	remove_action('admin_menu', '_add_themes_utility_last', 101);
}



//后台脚注
add_filter('admin_footer_text', 'remove_footer_admin');
function remove_footer_admin () {
	echo 'Fueled by <a href="http://www.wordpress.org" target="_blank">WordPress</a> | Designed by <a href="http://blueria.cn" target="_blank">Blueria</a>';
}


//替换谷歌字体源地址
// add_filter('style_loader_tag', 'blueria_replace_googlefonts', 1000, 1);
// function blueria_replace_googlefonts($text) {
// 	return str_replace('//fonts.googleapis.com/', '//fonts.useso.com/', $text);
// }

// 禁用谷歌开源字体
add_action( 'init', 'blueria_remove_open_sans' );
function blueria_remove_open_sans() {
	wp_deregister_style( 'open-sans' );
	wp_register_style( 'open-sans', false );
	wp_enqueue_style( 'open-sans', '' );
}



//缓存导航菜单 网站加速
//水煮鱼的这个方法存在很大问题 http://blog.wpjam.com/m/cache-wp_nav_menu/
// add_filter( 'pre_wp_nav_menu', 'blueria_get_nav_menu_transient_cache', 10, 2 );
// function blueria_get_nav_menu_transient_cache( $nav_menu = null, $args ) {
// 	var_dump($args);return;
// 	// 思路 直接根据$args->theme_location及$args其他信息来获取菜单项 将对象数据存入transient_cache
// 	// 用的时候取出来再处理 参阅wp-includes\nav-menu-template.php里的wp_nav_menu函数
// 	$cache_key = blueria_nav_menu_transient_cache_key( $args );
// 	$cached_menu = get_transient( $cache_key );
// 	if ( ! empty( $cached_menu ) )
// 		return $cached_menu;

// 	return $nav_menu;
// }
// add_filter( 'wp_nav_menu', 'blueria_set_nav_menu_transient_cache', 10, 2 );
// function blueria_set_nav_menu_transient_cache( $nav_menu, $args ) {
// 	$cache_key = blueria_nav_menu_transient_cache_key( $args );
// 	set_transient( $cache_key, $nav_menu, DAY_IN_SECONDS );
// 	return $nav_menu;
// }
// function blueria_nav_menu_transient_cache_key( $args ) {
// 	return 'blueria_nav_menu-' . substr( md5($args->theme_location), 8, 16 );	//不能超过45个字符
// }
// //更新菜单时清理缓存
// add_action( 'wp_update_nav_menu', 'blueria_del_nav_menu_transient_cache' );
// function blueria_del_nav_menu_transient_cache( $menu_id = 0, $menu_data = null ) {
// 	// delete_transient( 'nav-menu-cache-timestamp' );
// }



// if( isset($_GET['debug']) ) {
// 	define('SAVEQUERIES', true);
// 	// define('WP_DEBUG', true); // false

// 	add_action('wp_footer','wpjam_debug_footer');
// 	function wpjam_debug_footer(){
// 		global $wpdb;
// 		echo get_num_queries();echo ' queries in ';timer_stop(1);echo ' seconds.<br>';
// 		echo '按执行顺序：<br>';
// 		echo '<pre>';
// 		var_dump($wpdb->queries);
// 		echo '</pre>';
// 	}
// }


function blueria_what_page() {
	print is_home() ? "is_home " : " ";
	print is_page() ? "is_page " : " ";
	print is_single() ? "is_single " : " ";
		print is_attachment() ? "is_attachment " : " ";
	print is_archive() ? "is_archive " : " ";
		print is_tax() ? "is_tax " : " ";
		print is_category() ? "is_category " : " ";
		print is_tag() ? "is_tag " : " ";
		print is_author() ? "is_author " : " ";
		print is_date() ? "is_date " : " ";
		print is_post_type_archive() ? "is_post_type_archive " : " ";
	print is_search() ? "is_search " : " ";
	print is_404() ? "is_404 " : " ";
}
// add_action('wp_footer','blueria_what_page');


//主题设置 写入到配置文件[conf.php]
function setConfigValue($var, $value) {
	$file = TEMPLATEPATH."/conf.php";
	$config = file_get_contents($file);
	if( !is_serialized($value) ) $value = maybe_serialize($value);
	if ( preg_match("/". preg_quote("\${$var} = <<<VALUE") ."/U", $config) ) {
		$new = preg_replace("/". preg_quote("\${$var} = <<<VALUE") .".*VALUE;/sU", "\${$var} = <<<VALUE\n{$value}\nVALUE;", $config);	//preg_filter php5.3才支持
		$ok = file_put_contents($file, $new);
		return $ok ? true : false;
	} else {
		$f = fopen($file, "a");	//写入方式打开 指针指向到文件尾
		$ok = fwrite($f, "\n\${$var} = <<<VALUE\n{$value}\nVALUE;\n");	//在文件尾插入
		fclose($f);
		return $ok ? true : false;
	}
}
function blueria_get_option($option, $default = false) {	//代替原生的get_option()
	if ( isset($GLOBALS[$option]) ) {
		$option = $GLOBALS[$option];
	} else {
		global $$option;
		$option = $$option;
	}
	$option = maybe_unserialize( $option );
	return $option;
}


//HTML5预加载
add_filter( 'previous_post_rel_link', 'blueria_html5_preload' );
add_filter( 'next_post_rel_link', 'blueria_html5_preload' );
function blueria_html5_preload( $link ) {
	$prefetch = str_replace( array("prev", "next"), "prefetch", $link );
	$prerender = str_replace( array("prev", "next"), "prerender", $link );
	return $link.$prefetch.$prerender;
}


//强制is_home
//当使用query_posts并设置category_name参数时 那么is_home就为false了
//如果有必要is_home时 传一个blueria_is_home参数给query_posts就可以了
// add_action('parse_query', 'blueria_is_home');
// function blueria_is_home($wp_query) {
// 	if ( isset($wp_query->query_vars['blueria_is_home']) )
// 		$wp_query->is_home = true;
// }



//功能增强 get_terms的参数$args['orderby']的值可以设置为rand 即:随机
add_filter('get_terms_orderby', 'blueria_terms_orderby_rand', 10, 3);
function blueria_terms_orderby_rand($orderby, $args, $taxonomies) {
	if ($args['orderby'] == 'rand') {
		return 'RAND()';
	} else {
		return $orderby;
	}
}


//将作者显示为昵称
function nicename_as_displayname($author) {
	global $authordata;
	$nickname = get_user_meta($authordata->ID, 'nickname', true);
	// $user = get_userdata( $authordata->ID );
	// $nickname = $user->nickname;
	return $nickname;
}
// add_filter ('the_author', 'nicename_as_displayname');


// //用户管理页增加一列“昵称”
function add_user_nickname_column($columns) {
	unset($columns['name']);	//移除姓名一栏
	// $columns['user_nickname'] = '昵称';
	return $columns;
}
add_filter('manage_users_columns', 'add_user_nickname_column');
// function show_user_nickname_column_content($value, $column_name, $user_id) {
// 	$user = get_userdata( $user_id );
// 	$user_nickname = $user->nickname;
// 	if ( 'user_nickname' == $column_name )
// 		return $user_nickname;
// 	return $value;
// }
// add_action('manage_users_custom_column',  'show_user_nickname_column_content', 20, 3);



//获取分类id(不存在就创建)
function blueria_get_cat_id($name, $slug) {
	require_once (ABSPATH . '/wp-admin/includes/taxonomy.php');
	if ( !($cat_id = category_exists($slug)) )
		$cat_id = wp_insert_category( array('cat_name' => $name, 'category_nicename' => $slug) );
	return (int)$cat_id;
}


//获取term的id 通过其slug
function blueria_get_term_id($slug, $taxonomy) {
	$term = get_term_by('slug', $slug, $taxonomy);
	if ($term) return $term->term_id;
	else return '';
}


//获取term的link 通过其slug
function blueria_get_term_link($slug, $taxonomy) {
	$term = get_term_by('slug', $slug, $taxonomy);
	if ( $term ) {
		$link = get_term_link($term, $taxonomy);
		if ( is_wp_error($link) ) return '#';
		else return $link;
	} else {
		return '#';
	}
}


//获取terms列表
function blueria_terms_list($taxonomy, $parent = '') {
	$terms = get_terms($taxonomy, array(
		'hide_empty' => 0,
		'orderby' => 'id',
		// 'order' => 'DESC',
		'parent' => $parent
	));
	if ( !empty($terms) && !is_wp_error($terms) ) {
		$html = '<ul class="list clearfix">';
		foreach ($terms as $term) {
			$link = get_term_link($term, $taxonomy);
			$html .= "<li><a href=\"{$link}\">{$term->name}</a></li>\n";
		}
		$html .= '</ul>';
		return $html;
	} else {
		return false;
	}
}

//获取term的层级路径链接
function blueria_get_term_pathlink($term_or_id, $taxonomy, $link_prefix = '', $link_suffix = '') {
	if ( !$term_or_id ) return;
	$chain = '';
	$parent = get_term($term_or_id, $taxonomy);
	if ( is_wp_error($parent) ) return $parent;
	$name = $parent->name;
	$url = get_term_link($parent, $taxonomy);
	if ( $parent->parent && ( $parent->parent != $parent->term_id ) ) {	//如果$parent->parent=0就是顶级了
		$chain .= blueria_get_term_pathlink($parent->parent, $taxonomy, $link_prefix , $link_suffix);
	}
	$chain .= " &gt; <a href=\"{$url}\">{$link_prefix}{$name}{$link_suffix}</a>";
	return $chain;
}


//获取指定文章的首选term
function blueria_the_first_term($post_id, $taxonomy = array('category')) {
	$terms = get_the_terms($post_id, $taxonomy);
	if ( $terms && ! is_wp_error($terms) ) {
		return array_shift( $terms );	//取出数组第一个值
	} else {
		return false;
	}
}


//获取指定文章的首选term链接
function blueria_the_first_term_link($post_id, $taxonomy) {
	$terms = get_the_terms($post_id, $taxonomy);
	if ( $terms && ! is_wp_error($terms) ) {
		$first = array_shift( $terms );	//取出数组第一个值
		$link = get_term_link($first->term_id, $first->taxonomy);
		if ( is_wp_error($link) ) return '未设置';
		else return "<a href=\"{$link}\">{$first->name}</a>";
	} else {
		return '未设置';
	}
}


//数组操作 将指定的值放在第一个 并取出一定长度
function array_slice_sort($arr, $v, $length) {
	$index = array_search($v, $arr);	//搜索值在数组中的索引
	if (false === $index) return false;
	unset($arr[$index]);
	array_unshift($arr, $v);
	return array_slice($arr, 0, $length);
}


//获取信息发布的相对时间(针对性修改)
function blueria_publish_time() {
	$currentTime = current_time('timestamp');
	$pubTime = get_the_time('U');
	$timeDiff = $currentTime - $pubTime;
	if ($timeDiff <= 2592000) {
		$time_str = human_time_diff($pubTime, $currentTime)."前";
	} else {
		$time_str = get_the_time('Y/m/d');
	}
	echo $time_str;
}


//获取文章的标签(纯文字+色彩编号)
function blueria_the_colorful_tags() {
	$tags = get_the_tags();
	if ( !$tags ) return;
	foreach ($tags as $tag) {
		$name = $tag->name;
		$tid = (string)$tag->term_id;
		$color = "color_".substr($tid, -1);	//id的各位数字 生成10种色彩class
		echo "<span class=\"{$color}\">{$name}</span>";
	}
}





//执行文本小工具里的短代码(简洁写法)
add_filter('widget_text', 'do_shortcode');


//菜单冗余class过滤
add_filter('nav_menu_css_class', 'blueria_menu_attributes_filter', 100, 1);
add_filter('nav_menu_item_id', 'blueria_menu_attributes_filter', 100, 1);
add_filter('page_css_class', 'blueria_menu_attributes_filter', 100, 1);
function blueria_menu_attributes_filter($classes) {
	if ( !is_array($classes) ) return '';
	return array_filter($classes, "blueria_menu_attributes_filter_callback");
}
function blueria_menu_attributes_filter_callback($v) {
	return !preg_match("/^(menu\-item\-|page\-item\-)/", $v);	//过滤掉 以menu-item-开头的 或者 以page-item-开头的class
}


//获取指定post_type的文章总数 (WP本身有这个函数 wp_count_posts)
function blueria_total_posts($post_type = 'post') {
	global $wpdb;
	$total = wp_cache_get('total_posts', "post_type_".$post_type);
	if (false === $total) {
		$total = $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM $wpdb->posts WHERE post_type = '%s' AND post_status = 'publish';", $post_type));
		wp_cache_set('total_posts', (int)$total, "post_type_".$post_type);
	}
	echo (int)$total;
}


//获取页面id 根据页面slug
function blueria_get_page_id( $slug ) {
	$page = get_page_by_path( $slug );
	if ( $page )
		return $page->ID;
}

//获取页面固定链接 根据页面slug
function blueria_get_page_link( $slug ) {
	global $wp_rewrite;
	$link = $wp_rewrite->get_page_permastruct();
	
	if ( !empty($link) ) {	//检测rewrite是否开启
		$link = home_url($slug);
		$link = user_trailingslashit($link, 'page');
		return $link;
	} else {
		$page = get_page_by_path( $slug );
		if ( $page )
			return get_page_link( $page->ID );	
	}
}

//相邻文章url
function blueria_adjacent_post_link($rel = 'prev') {
	if ($rel == 'prev') {
		$post = get_adjacent_post();
	} else if ($rel == 'next') {
		$post = get_adjacent_post(false, '', false);
	}
	if ( empty( $post ) ) return;
	return get_permalink( $post );
}


//获取重定向返回地址
function get_redirect_url() {
	return parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH);
}


//结果只有一个时 直接重定向到文章
function blueria_redirect_single_post($wp_query) {
	if ($wp_query->post_count == 1) {
		wp_redirect( get_permalink( $wp_query->posts['0']->ID ) );
	}
}


//GET参数中存在 则添加current类
function selected_class($k, $v) {
	if ( isset($_GET[$k]) ) {
		if ($_GET[$k] == $v) echo 'class="current"';
	} else if ( empty($v) ) {
		echo 'class="current"';
	}
}


//附加成功与否状态码在请求地址上
function urlStatus($is_success, $status_code) {
	$redirect = stripslashes($_SERVER["REQUEST_URI"]);	//请求地址
	if ( $is_success ) {
		$redirect = remove_query_arg('error', $redirect);
		$redirect = add_query_arg(array('success'=>$status_code), $redirect);
	} else {
		$redirect = remove_query_arg('success', $redirect);
		$redirect = add_query_arg(array('error'=>$status_code), $redirect);
	}
	wp_redirect($redirect);
	exit();
}


//生成插件安装地址
function blueria_plugin_install_url($plugin, $echo = true) {
	$action = 'install-plugin_'.$plugin;
	$actionurl = 'update.php?action=install-plugin&plugin='.$plugin;
	$url = wp_nonce_url( $actionurl, $action );
	if ( $echo ) {
		echo $url;
	} else {
		return $url;
	}
}


//添加自定义页面(可能需要优化)
function blueria_add_page($name, $slug, $tpl_filename = null, $post_type = 'page', $content = '') {
	global $wpdb;
	$id = $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE post_name = '{$slug}' AND post_type = '{$post_type}'");
	if ($id) return true;	//如果存在就到此为止

	$page = array(
		'post_title' => $name,
		'post_name' => $slug,
		'post_content' => $content,
		'post_author' => 1,	
		'post_status' => 'publish',
		'comment_status' => 'closed',
		'ping_status' => 'closed',
		'post_type' => $post_type
	);
	$postID = wp_insert_post($page);
	if ($postID) {
		if ($tpl_filename) add_post_meta($postID, '_wp_page_template', $tpl_filename);
		return true;
	} else {
		return false;
	}
}


//创建term（带名称）
function blueria_create_term($name, $slug, $taxonomy) {
	if ( $id = term_exists($name, $taxonomy) ) return $id;
	return wp_insert_term($name, $taxonomy, array('slug' => $slug));
}




//删除本地文件
function blueria_del_file($file) {
	try{
		if( !@file_exists($file) ) return TRUE;
		if( !@unlink($file) ) return FALSE;
		return TRUE;
	} catch(Exception $e){
		return FALSE;
	}
}


//判断gif是否为动画（而不是单帧图）
function IsAnimatedGif($filename) {
	$fp = fopen($filename, 'rb');
	$filecontent = fread($fp, filesize($filename));
	fclose($fp);
	return strpos( $filecontent, chr(0x21).chr(0xff).chr(0x0b).'NETSCAPE2.0' ) === FALSE ? flase : true;
}