<?php
header("Content-type: text/html; charset=utf-8");
// set_time_limit(0);

//head部输出处理方案
remove_action( 'wp_head', 'rsd_link' );
remove_action( 'wp_head', 'wlwmanifest_link' );
remove_action( 'wp_head', 'index_rel_link' );
remove_action( 'wp_head', 'parent_post_rel_link', 10, 0 );
remove_action( 'wp_head', 'start_post_rel_link', 10, 0 );
remove_action( 'wp_head', 'adjacent_posts_rel_link', 10, 0 );
remove_action( 'wp_head', 'wp_generator' );
//顶部28px的空白处理方案
add_filter( 'show_admin_bar' , '__return_false');//margin-top: 28px
//显示[链接]菜单
add_filter( 'pre_option_link_manager_enabled', '__return_true' );
//特色图像
// add_theme_support( 'post-thumbnails' );
set_post_thumbnail_size( 120, 90, true );		//默认特色图像尺寸(post-thumbnail)
add_image_size( 'w300h225', 300, 225, true );	//适合侧边栏使用的缩略图


include_once dirname(__FILE__)."/fn.php";
include_once dirname(__FILE__)."/seo.php";
include_once dirname(__FILE__)."/conf.php";
include_once dirname(__FILE__)."/inc/sina/sina-connect.php";
include_once dirname(__FILE__)."/inc/qq/qq-connect.php";





//更改页面请求参数(最小查询量)
add_action('pre_get_posts','blueria_wp_query');
function blueria_wp_query( $query ) {
	if ( is_home() && $query->is_main_query() )				//首页
		$query->set('category_name', 'video,image,text');	//只取这3个分类的文章
	if ( is_tax('topic') && $query->is_main_query() )		//topic页
		$query->set('posts_per_page', 20);					//每页显示文章数
}





add_action('wp_head', 'blueria_head_init', 0);
function blueria_head_init() {
	$base_options = get_option('base_options', blueria_get_option('base_options')); 
	$ui_style = get_option('ui_style', blueria_get_option('ui_style')); 
	echo "<script type=\"text/javascript\">\n";
	if ( is_active_widget(false, false, 'blueria_visitors', true) ) {
		echo "var duoshuoQuery = {short_name:\"{$base_options['duoshuo_short_name']}\"};\n";
	}
	if ( is_numeric(@$ui_style['nav_height']) ) {
		echo "var nav_height = ".@$ui_style['nav_height'].";\n";
	}
	if ( @$ui_style['nav_nofollow'] == 'on' ) {
		echo "var nav_nofollow = \"on\";\n";
	} else {
		echo "var nav_nofollow = \"off\";\n";
	}
	if ( @$base_options['click_image_enter'] == 'on') {
		echo "var image_enter = \"on\";\n";
	} else {
		echo "var image_enter = \"off\";\n";
	}
	if ( @$base_options['click_video_enter'] == 'on') {
		echo "var video_enter = \"on\";\n";
	} else {
		echo "var video_enter = \"off\";\n";
	}
	echo "var isSingle = ".(is_single() ? 'true' : 'false').";\n";
	echo "</script>\n";
}

//引用JS
add_action('wp_enqueue_scripts', 'theme_enqueue_scripts', 0);
function theme_enqueue_scripts() {
	wp_enqueue_script("jquery");	//jQuery
	wp_enqueue_script("swfobject");	//SWFObject
	if ( is_active_widget(false, false, 'blueria_visitors', true) ) {
		wp_enqueue_script("duoshou", 'http://static.duoshuo.com/embed.js', array(), false, true );
	}
}




//作者以下的角色 无法进入后台
//这里有bug 登陆后ajax无法请求 等待修复
// add_action('admin_init', 'blueria_redirect_member');
function blueria_redirect_member() {
	global $current_user;
	if ( ! $current_user->has_cap('publish_posts') )
		wp_redirect( blueria_get_page_link('member') );
}


//登陆保护
// add_action('login_enqueue_scripts', 'login_protection');
// function login_protection() {
// 	if( $_GET['word'] != 'press' )
// 		header('Location: '.home_url());
// }





//后台脚本及样式
add_action('admin_enqueue_scripts', 'blueria_admin_scripts');
function blueria_admin_scripts() {
	// wp_enqueue_script( 'custom-header' );
	wp_enqueue_script( 'blueria_admin', get_bloginfo('template_url').'/admin/script.js', array('jquery', 'wp-color-picker'), false, true );
	wp_enqueue_style( 'wp-color-picker' );
	wp_enqueue_style( 'blueria_admin', get_bloginfo('template_url').'/admin/style.css' );
}

//菜单
if ( function_exists('register_nav_menus') ) {
	register_nav_menus(array('nav_menu' => '导航菜单', 'foot_menu' => '页脚菜单'));
}






//侧边栏
if ( function_exists('register_sidebar') ) {
	register_sidebar(array('name'=>'首页侧边栏', 'id'=>'home_sidebar'));
	register_sidebar(array('name'=>'内页侧边栏', 'id'=>'post_sidebar'));
	register_sidebar(array('name'=>'通用侧边栏', 'id'=>'common_sidebar'));
}
include_once dirname(__FILE__)."/inc/widgets.php";






//后台菜单排序
// add_filter('custom_menu_order', '__return_true');
// add_filter('menu_order', 'blueria_admin_menu_order');
// function blueria_admin_menu_order( $menu_order ) {
// 	return array( 'index.php', 'site-settings', 'separator1', 'edit.php', 'upload.php', 'link-manager.php' );
// }


//主题设置
add_action('admin_menu', 'bleria_theme_settings', 8);
function bleria_theme_settings(){	  
	add_menu_page( '网站设置', '网站设置', 'administrator', 'site-settings', 'Theme_settings', 'dashicons-admin-generic', 3 );
	add_submenu_page( 'site-settings', '界面样式', '界面样式', 'administrator', 'ui-style', 'UI_Style' );
}  
function Theme_settings() {
	include_once dirname(__FILE__)."/inc/settings.php";
}
function UI_Style() {
	include_once dirname(__FILE__)."/inc/ui-style.php";
}


//主题设置保存操作
add_action('wp_ajax_blueria_theme_settings', 'blueria_theme_settings');
function blueria_theme_settings() {
	if ( !current_user_can('manage_options') ) die('-2');

	if ( empty($_POST['type']) || empty($_POST['data']) ) die('0');
	$type = $_POST['type'];
	$data = $_POST['data'];

	$safe_options = array('site_options', 'base_options', 'ui_style');
	if ( in_array($type, $safe_options) ) {
		parse_str($data, $D);
		array_walk_recursive($D[$type], create_function('&$value, $key', '$value = stripslashes($value);'));	//删除反斜杠
		$ok = update_option($type, $D[$type]);
		
		if ($ok) echo "ok";
		else die('-1');
	}
	if ( 'tougao_options' == $type ) {
		parse_str($data, $D);
		array_walk_recursive($D, create_function('&$value, $key', '$value = str_replace(array("，", " "), array(",", ""), $value);'));	//去掉空格 将中文逗号改为英文半角逗号
		$ok = update_option($type, $D);
		
		if ($ok) echo "ok";
		else die('-1');
	}

	die();
}




//给子菜单添加一个箭头
class Blueria_Nav_Menu_Walker extends Walker_Nav_Menu {
	function end_lvl( &$output, $depth = 0, $args = array() ) {
		$indent = str_repeat("\t", $depth);
		$output .= "$indent<span class=\"arrow\"></span></ul>\n";
	}
}





//添加一个"专题"tax
add_action('init', 'blueria_register_tax', 0);
function blueria_register_tax() {
	$labels = array(
		'name'			  => '专题',
		'all_items'		 => '所有专题',
		'edit_item'		 => '编辑专题',
		'update_item'	   => '更新专题',
		'add_new_item'	  => '添加专题',
		'new_item_name'	 => '新专题名称',
		'search_items'	  => '搜索专题',
	);
	$args = array(
		'hierarchical'	  => true,		//类似于分类 分级 可有子元素
		'labels'			=> $labels,
		'show_admin_column' => true,		//显示在post_type的管理列里
		'show_ui'		   => true,		//显示在快速编辑里
		'query_var'		 => true,
		'sort'				=> true,
		'capabilities'		=> array(
			'assign_terms'	=> 'read',	//这样设置 要不然前台投稿无法设置"topic"
		)
	);
	register_taxonomy( 'topic', array('post'), $args );
}
add_action('load-edit-tags.php', 'blueria_edit_tax');
function blueria_edit_tax() {
	wp_enqueue_media();
	add_action('quick_edit_custom_box', 'blueria_quick_edit_custom_box', 10, 3);
}
//添加新专题表单的field
add_action('topic_add_form_fields', 'blueria_addform_fields');
function blueria_addform_fields( $tax ) {
	echo '<div class="form-field tax-thumb">
		<span>封面图</span>
		<div class="thumb_box"><img src="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7" class="tax_thumb_img" width="160" height="120" /></div>
		<p>点击上图进行选择或上传</p>
		<p>宽高比4:3 尺寸≥160x120像素</p>
		<input type="hidden" name="tax_thumb_id" id="tax_thumb_id" />
	</div>';
}
//快速编辑
function blueria_quick_edit_custom_box($column_name, $screen, $name) {
	if ($column_name == 'thumb') 
		echo '<fieldset>
			<div class="thumb inline-edit-col">
				<label>
					<span class="title">封面</span>
					<span class="input-text-wrap">
						<input type="hidden" name="tax_thumb_id" class="tax_thumb_id" />
						<button class="button button-small tax_thumb_quick_edit">选择或上传</button>
						<span class="tips"></span>
					</span>
				</label>
			</div>
		</fieldset>';
}
//内部编辑表单的field
add_action('topic_edit_form_fields', 'blueria_editform_fields');
function blueria_editform_fields( $term ) {
	$style = "";
	$topics_img = get_option('yeti_topics_image');
	if ( $topics_img && $img_id = $topics_img[$term->term_id] ) {
		$src = wp_get_attachment_image_src( (int)$img_id, 'thumbnail' );
		$style = "style=\"background-image: url({$src[0]});\"";
	}
	echo '<tr class="form-field">
			<th scope="row"><label for="slug">封面</label></th>
			<td><input type="hidden" name="tax_thumb_id" id="tax_thumb_id" />
			<div class="thumb_box"><img src="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7" class="tax_thumb_img" width="160" height="120" '.$style.' /></div>
			<p class="description">点击上图进行选择或上传</p></td>
		</tr>';
}
//创建或更新专题时
add_action('edit_term', 'blueria_save_tax_thumb');
add_action('create_term', 'blueria_save_tax_thumb');
function blueria_save_tax_thumb( $term_id ) {
	if( isset($_POST['tax_thumb_id']) && !empty($_POST['tax_thumb_id']) ) {
		$img_id = intval($_POST['tax_thumb_id']);
		$topics_img = get_option('yeti_topics_image');
		if ( !$topics_img ) {
			update_option('yeti_topics_image', array("{$term_id}" => $img_id));
		} else {
			$topics_img = (array) $topics_img;
			$topics_img["{$term_id}"] = $img_id;
			update_option('yeti_topics_image', $topics_img);
		}
	}
}
//缩略图管理列
add_filter( 'manage_edit-topic_columns', 'blueria_edit_tax_columns' );
add_filter( 'manage_topic_custom_column', 'blueria_tax_custom_column', 10, 3 );
function blueria_edit_tax_columns( $columns ) {
	$new_columns = array();
	$new_columns['cb'] = $columns['cb'];
	$new_columns['thumb'] = '封面';
	unset( $columns['cb'] );
	return array_merge( $new_columns, $columns );
}
function blueria_tax_custom_column( $columns, $column, $id ) {
	if ( $column == 'thumb' ) {
		$topics_img = get_option('yeti_topics_image');
		if ( $topics_img ) {
			$img_id = $topics_img[$id];
			if ( $img_id ) {
				$src = wp_get_attachment_image_src( (int)$img_id, 'post-thumbnail' );
				$columns = "<span class='thumb_box_small'><img src='{$src[0]}' /></span>";
			} else {
				$columns = "<span class='thumb_box_small'></span>";
			}
		} else {
			$columns = "<span class='thumb_box_small'></span>";
		}
	}
	return $columns;
}















//TinyMCE
add_action( 'admin_init', 'blueria_tinymce_button' );
function blueria_tinymce_button() {
	if ( current_user_can( 'edit_posts' ) && current_user_can( 'edit_pages' ) ) {
		add_filter( 'mce_buttons', 'bluetao_mce_buttons' );
		add_filter( 'mce_buttons_2', 'bluetao_mce_buttons2' );
		add_filter( 'mce_external_plugins', 'bluetao_plugin_register' );
		add_editor_style( 'admin/mce-view.css' );
	}
}
//添加mce按钮
function bluetao_mce_buttons($buttons) {
	$btns = array();
	$btns[] = 'bold';			//加粗
	$btns[] = 'italic';			//斜体
	$btns[] = 'strikethrough';	//删除线
	$btns[] = 'blockquote';		//引用
	$btns[] = 'bullist';		//符号列表
	$btns[] = 'numlist';		//编号列表
	$btns[] = 'alignleft';		//左对齐
	$btns[] = 'aligncenter';	//居中对齐
	$btns[] = 'alignright';		//右对齐
	$btns[] = 'alignjustify';	//两端对齐
	$btns[] = 'link';			//链接
	$btns[] = 'unlink';			//取消链接
	$btns[] = 'table';			//表格
	$btns[] = 'hr';				//水平线
	$btns[] = 'wp_more';		//more分隔
	$btns[] = 'wp_page';		//分页
	$btns[] = 'removeformat';	//清除格式
	$btns[] = 'undo';			//撤销
	$btns[] = 'redo';			//重做
	$btns[] = 'fullscreen';		//全屏
	$btns[] = 'wp_adv';
	return $btns;
}
function bluetao_mce_buttons2($buttons) {
	$btns = array();
	$btns[] = 'formatselect';	//格式选择
	$btns[] = 'fontsizeselect';	//字体选择
	$btns[] = 'forecolor';		//字体色
	$btns[] = 'backcolor';		//背景色
	$btns[] = 'outdent';		//减缩进
	$btns[] = 'indent';			//增缩进
	$btns[] = 'charmap';		//特色字符
	$btns[] = 'BVideo';
	$btns[] = 'BGallery';
	$btns[] = 'BImage';
	return $btns;
}
//mce按钮脚本
function bluetao_plugin_register($plugins) {
	$plugins['BVideo'] = get_bloginfo('template_url').'/admin/mce-bvideo.js';
	$plugins['BGallery'] = get_bloginfo('template_url').'/admin/mce-bgallery.js';
	$plugins['BImage'] = get_bloginfo('template_url').'/admin/mce-bimage.js';
	return $plugins;
}
//mce短代码视图
add_action('load-post.php', 'blueria_mce_view');
function blueria_mce_view() {
	wp_enqueue_script( 'blueria_mce-view', get_bloginfo('template_url').'/admin/mce-view.js', array('jquery') );	//自定义mce短代码视图
}
//短代码的编辑器模板
add_action('print_media_templates', 'blueria_print_editor_tmpl');
function blueria_print_editor_tmpl() {
$html = <<<HTML
<script type="text/html" id="tmpl-editor-bvideo">
	<div class="toolbar">
		<div class="dashicons dashicons-edit edit"></div>
		<div class="dashicons dashicons-no-alt remove"></div>
	</div>
	<# if ( data.attr.img ) { #>
		<div class="mceTemp"><dl class="wp-caption">
			<dt class="wp-caption-dt"><img src="{{ data.attr.img }}" /></dt>
			<dd class="wp-caption-dd wp-caption-text">视频源: {{ data.attr.type }}　视频ID: {{ data.attr.vid }}</dd>
		</dl></div>
	<# } else { #>
		<div class="wpview-error wp-caption">
			<p style="padding:0 10px;color:#FF6A6A;">视频解析出错，请尝试重新解析！</p>
		</div>
	<# } #>
	<div class="wpview-overlay play"></div>
</script>
<script type="text/html" id="tmpl-editor-bimage">
	<div class="toolbar">
		<div class="dashicons dashicons-no-alt remove"></div>
	</div>
	<# if ( "1" === data.attr.gif ) { #>
		<img src="{{ data.attr.thumb }}" />
	<# } else if ( data.attr.url && data.attr.width && data.attr.height ) { #>
		<img src="{{ data.attr.url }}" />
	<# } else { #>
		<div class="wpview-error wp-caption">
			<p style="padding:0 10px;color:#FF6A6A;">未知错误，请删除后重新插入！</p>
		</div>
	<# } #>
	<div class="wpview-overlay"></div>
</script>
HTML;
echo $html;
}

//重新汉化相册面板
add_filter('gettext', 'blueria_text_strings', 10, 3);
add_filter('gettext_with_context', 'blueria_text_strings', 10, 3);
function blueria_text_strings($translated_text, $text, $domain) {
	switch ( $text ) {
		case '&#8592; Cancel Gallery':
			$translated_text = "<<< 取消组图";
			break;
		case 'Edit Gallery':
			$translated_text = "编辑组图";
			break;
		case 'Add to Gallery':
		case 'Add to gallery':
			$translated_text = "添加至组图";
			break;
		case 'Insert gallery':
			$translated_text = "插入组图";
			break;
		case 'Update gallery':
			$translated_text = "更新组图";
			break;
	}
	return $translated_text;
}


//后台解析视频
add_action('wp_ajax_blueria_parse_video_info', 'blueria_parse_video_info');
function blueria_parse_video_info($url = null) {
	$is_ajax_request = false;
	if ( $url == null ) {
		if ( !current_user_can('edit_post') ) exit('-1');
		if (!isset($_POST['url']) || empty($_POST['url'])) exit('0');
		$url = $_POST['url'];
		$is_ajax_request = true;
	}

	include_once dirname(__FILE__)."/inc/VideoUrlParser.php";
	$vdo = new VideoUrlParser($url);
	if ($vdo->success == 1) {
		if ( $vdo->from == 'tudou' ) {
			$shortcode = "[bvideo type=\"{$vdo->from}\" vid=\"{$vdo->vid}\" code=\"{$vdo->code}\" lcode=\"{$vdo->lcode}\" iid=\"{$vdo->iid}\" img=\"{$vdo->img}\" thumb=\"{$vdo->thumb}\" url=\"{$url}\"]";
		} else {
			$shortcode = "[bvideo type=\"{$vdo->from}\" vid=\"{$vdo->vid}\" iid=\"{$vdo->iid}\" img=\"{$vdo->img}\" thumb=\"{$vdo->thumb}\" url=\"{$url}\"]";
		}
	} else {
		$shortcode = (string) $vdo->success;	//解析不成功
	}
	
	if ( $is_ajax_request ) {
		exit($shortcode);
	} else {
		return $shortcode;
	}
}


//解析gif图 并生成其他类型图的缩略图
add_action('wp_ajax_blueria_img_handler', 'blueria_img_handler');
function blueria_img_handler($url = null, $id = 0) {
	$is_ajax_request = false;
	if ( $url == null ) {
		if ( !current_user_can('edit_post') ) exit('-1');
		if ( !isset($_POST['url']) || empty($_POST['url']) || !isset($_POST['id']) ) exit('0');
		$url = $_POST['url'];
		$id = intval($_POST['id']);
		$is_ajax_request = true;
	}
	$id = isset($id) ? $id : 0;

	$host = $_SERVER['HTTP_HOST'];
	$from = preg_match("#".preg_quote($host)."#", $url) ? 'in' : 'out';	//是否是内部资源

	include_once dirname(__FILE__).'/inc/fastimage.php';
	try {
		$image = new FastImage($url);
	} catch (Exception $e) {
		if ( $is_ajax_request ) exit($e->getMessage());
		return $e->getMessage();
	}
	$type = $image->getType();
	if ( !$type ) {	//格式错误
		if ( $is_ajax_request ) exit('-1');
		return '-1';
	}

	$img_size = $image->getSize();
	$img_name = md5($url).".".$type;	//图片存储名称
	$wp_updir = wp_upload_dir();		//使用函数获取目录的原因是 多站点时 目录是不一样的
	$img_file = $wp_updir['basedir'].'/yeti/'.$img_name;
	$img_url = $wp_updir['baseurl']."/yeti/".$img_name;

	if ('gif' == $type) {	//只静态化gif图
		include_once dirname(__FILE__).'/inc/GifFrameExtractor.php';
		blueria_del_file( $img_file );	//如果存在 先将其删除

		$get = wp_remote_get( $url, array(
			'timeout' => 0,
			'redirection' => 20,
			'sslverify' => FALSE)
		);
		if ( is_wp_error($get) ) {
			if ( $is_ajax_request ) exit( $get->get_error_message() );		//产生http请求错误
			return $get->get_error_message();
		}
		$img_bits = wp_remote_retrieve_body( $get );
		$mirror = wp_upload_bits($img_name, '', $img_bits, 'yeti');	//存图片 返回本地图片['file', 'url'] ('yeti'是存储目录 但这是不合要求的写法)

		if ( ! file_exists($img_file) ) {	//文件下载失败
			if ( $is_ajax_request ) exit('-3');
			return '-3';
		}

		// if ( GifFrameExtractor::isAnimatedGif($img_file) ){
		// 	$gfe = new GifFrameExtractor();
		// 	$gfe->extract( $img_file );		//提取目标gif文件帧
		// } else {
		// 	if ( $is_ajax_request ) exit('-2');	//gif格式错误
		// 	return '-2';
		// }
		
		// if ($gfe->getFrameNumber() > 1) {	//如果大于1帧 说明是动图
		// 	foreach ($gfe->getFrames() as $index => $frame) {
		// 		if ( is_resource($frame['image']) )
		// 			imagegif($frame['image'], $img_file);	//覆盖掉
		// 		break;	//只取第一张
		// 	}
		// 	$gif = 1;
		// 	$thumb = $img_url;
		// } else {	//否则只是一张静态的gif图
		// 	blueria_generate_thumb($url, $img_name);
		// 	$gif = 0;
		// 	$thumb = "";
		// }
		if ( IsAnimatedGif($img_file) ) {	//是否为动图
			$image = wp_get_image_editor( $img_file );
			if ( ! is_wp_error( $image ) ) {
				$image->save( $img_file );	//覆盖
			}
			$gif = 1;
			$thumb = $img_url;
		} else {	//否则只是一张静态的gif图
			blueria_generate_thumb($url, $img_name);
			$gif = 0;
			$thumb = "";
		}
	} else {
		if ($from == 'out') blueria_generate_thumb($url, $img_name);	//内部的 已经有缩略图了
		$gif = 0;
		$thumb = "";
	}

	list($w, $h) = $img_size;
	// $result = "[\"{$from}\", \"{$w}\", \"{$h}\", \"{$gif}\", \"{$thumb}\"]";	//标准josn
	$shortcode = "[bimage from=\"$from\" id=\"{$id}\" url=\"{$url}\" thumb=\"{$thumb}\" width=\"{$w}\" height=\"{$h}\" gif=\"{$gif}\" alt=\"\"]";
	
	if ( $is_ajax_request ) exit($shortcode);
	return $shortcode;
}
function blueria_generate_thumb($url, $img_name) {
	$wp_updir = wp_upload_dir();
	$img_file = $wp_updir['basedir'].'/yeti/'.$img_name;

	if ( !file_exists($img_file) ) {
		$get = wp_remote_get( $url, array(
			'timeout' => 0,
			'redirection' => 20,
			'sslverify' => FALSE
		));
		$img_bits = wp_remote_retrieve_body( $get );
		$mirror = wp_upload_bits($img_name, '', $img_bits, 'yeti');

		$image = wp_get_image_editor( $img_file );
		if ( ! is_wp_error( $image ) ) {
			$image->resize( 120, 90, true );
			$image->save( $img_file );	//覆盖
		}
	}
}









//特色图像
add_action( 'add_meta_boxes', 'blueria_featured_image_metabox' );
function blueria_featured_image_metabox() {
	add_meta_box('blueria_featured_image_metabox', '[雪人]特色图像', 'blueria_featured_image_callback', 'post', 'side', 'high');
}
function blueria_featured_image_callback( $post, $metabox ) {
	$featured_image = get_the_post_thumbnail( $post->ID );

	$preview_block = "";
	if ( $featured_image ) {
		$preview_block .= "<div class='preview_block' style='text-align: center;'>";
		$preview_block .= $featured_image;
		$preview_block .= "</div>";
	} else {
		$preview_block .= "<div class='preview_block'>";
		$preview_block .= "<p>特色图像区域 无需手动设置</p>";
		$preview_block .= "<p>文章保存时 自动从文章最前面提取</p>";
		$preview_block .= "<p>选取[视频缩略图/单图缩略图/相册第一张图]</p>";
		$preview_block .= "<p>纯文字文章 或其他形式的媒体 不设特色图像</p>";
		$preview_block .= "</div>";
	}
	echo $preview_block;
}


//提取特色图像
add_action( 'save_post', 'blueria_save_featured_image', 10, 2 );
function blueria_save_featured_image( $post_ID, $post ) {
	$content = $post->post_content;
	if ( ! preg_match("@\[(bimage|bvideo|gallery)([^\]]*)\]@is", $content, $matches) ) {
		$wp_featured_image = get_post_meta( $post_ID, '_thumbnail_id', true );
		if ( $wp_featured_image == '-1' ) delete_post_meta( $post_ID, '_thumbnail_id' );	//如果设置过 就删除
		return;
	}
	switch ( $matches[1] ) {
		case 'bimage':
			preg_match("@from=\"(in|out)\" id=\"(\d+)\" url=\"([^\"]*)\" thumb=\"([^\"]*)\".+gif=\"([01])\"@", $matches[0], $attrs);
			$from = $attrs[1];
			$id = intval( $attrs[2] );
			$gif = intval( $attrs[5] );
			if ($gif == 1 && $from == 'out') {	//只有站外的动图 才使用并且才有thumb参数
				$featured_image = array('type' => 'gif', 'img' => $attrs[4]);
			} else {
				$featured_image = array('type' => 'img', 'img' => $attrs[3]);
			}
			break;
		case 'bvideo':
			preg_match("@thumb=\"([^\"]*)\"@", $matches[0], $attrs);
			$featured_image = array('type' => 'vdo', 'img' => $attrs[1]);
			break;
		case 'gallery':
			preg_match("@ids=\"(\d+)@", $matches[0], $attrs);
			// $img = wp_get_attachment_image_src( (int)$attrs[1], 'post-thumbnail' );
			// $featured_image = $img[0];
			$id = intval( $attrs[1] );
			break;
	}
	if ( isset($id) && $id != 0 ) {
		update_post_meta( $post_ID, '_thumbnail_id', $id );
	} else {
		update_post_meta( $post_ID, 'featured_image_url', $featured_image );
		update_post_meta( $post_ID, '_thumbnail_id', -1 );	//这样做的目的是通过has_post_thumbnail()检测
	}
}

//显示特色图像
add_filter( 'post_thumbnail_html', 'blueria_display_featured_image', 10, 5 );
function blueria_display_featured_image( $html, $post_id, $post_thumbnail_id, $size, $attr ) {
	if ( $post_thumbnail_id == '-1' ) {	//如果没有特色图像数据
		// $post = get_post($post_id);
		// $title = strip_tags($post->post_title);
		$featured_image = get_post_meta( $post_id, 'featured_image_url', true );
		if ( is_array($featured_image) ) {
			$img_url = $featured_image['type'] != 'vdo' ? get_bloginfo('template_url')."/timthumb.php?src=".$featured_image['img'] : $featured_image['img'];
			$src = is_admin() ? " src=\"{$img_url}\"" : "";
			$html = "<img class=\"lazy\" data-original=\"{$img_url}\" width=\"120\" alt=\"缩略图\"{$src} />";
		} else {
			$html = "";
		}
	} else {
		if ( !is_admin() ) $html = preg_replace(array("/class=\"[^\"]*\"/iU", "/src=/iU"), array("class=\"lazy\"", "data-original="), $html);
	}
	
	if ( empty($html) && !is_admin() ) {
		$color = array("488FCE", "53A93F", "C184FF", "FF5E52", "e67e22", "1abc9c", "f1c40f");
		shuffle($color);
		return "<span class=\"text_thumb\" style=\"background-color: #{$color[0]};\"></span>";
	}

	return $html;
}


//兼容水煮鱼的微信机器人
add_filter('weixin_pre_thumb', 'thumb_to_wpjam_weixin_robot', 10, 3);
function thumb_to_wpjam_weixin_robot($thumb = false, $size, $post) {
	$thumb = get_the_post_thumbnail($post->ID);
	$src = preg_replace("/.*timthumb\.php\?src\=([^\"]+).*/i", "$1", $thumb);
	$src2 = ($thumb == $src) ? preg_replace("/.*data\-original=\"([^\"]+)\".*/i", "$1", $thumb) : $src;
	return ($src2 == $thumb) ? "" : $src2;
}



//自动文章分类
add_action( 'save_post', 'blueria_auto_post_category', 10, 2 );
function blueria_auto_post_category( $post_ID, $post ) {
	$content = $post->post_content;
	$txt_cat_id = blueria_get_cat_id('文字', 'text');
	$img_cat_id = blueria_get_cat_id('图片', 'image');
	$vdo_cat_id = blueria_get_cat_id('视频', 'video');
	$gif_cat_id = blueria_get_cat_id('Gif图', 'gif');

	if ( isset($_POST['code']) && isset($_POST['tags']) ) {		//前台投稿分类
		$cats_arr = !empty($_POST['cats']) ? (array)$_POST['cats'] : array();
	} else if ( isset($_POST['post_category']) ) {				//后台发布或更新文章
		$cats_arr = !empty($_POST['post_category']) ? (array)$_POST['post_category'] : array();
	} else {	//其他特情况 获取分类
		$cats_arr = wp_get_post_terms($post->ID, 'category', array('fields'=>'ids'));
	}
	
	if ( !empty($cats_arr) ) {
		$base_arr = array(0, $txt_cat_id, $img_cat_id, $vdo_cat_id);	//先排除掉这些id
		$cats_arr = array_diff($cats_arr, $base_arr);
		$cats_arr = array_map('intval', $cats_arr);		//将每一项转换为int型
	}

	if ( preg_match_all("@\[(bimage|bvideo|gallery)[^\]]*\]@s", $content, $matches) || preg_match_all("@\<(img)[^\>]+\>@s", $content, $matches) ) {}
	else {
		$cats_arr[] = $txt_cat_id;
		wp_set_object_terms( $post->ID, $cats_arr, 'category', false );
		return;
	}
	
	$shortcodes = $matches[1];	//匹配到的所有短代码(名称)
	
	if ( in_array("bimage", $shortcodes) || in_array("gallery", $shortcodes) || in_array("img", $shortcodes) ) { 
		$cats_arr[] = $img_cat_id;
		if ( preg_match("/ gif=\"1\" /Us", $content) ) $cats_arr[] = $gif_cat_id;
	}
	
	if ( in_array("bvideo", $shortcodes) ) {
		$cats_arr[] = $vdo_cat_id;
	}

	wp_set_object_terms( $post->ID, $cats_arr, 'category', false );
}









//短代码[gallery]
remove_shortcode('gallery');	//先移除原生的gallery
add_shortcode('gallery', 'blueria_gallery_shortcode');
function blueria_gallery_shortcode( $attr ) {
	if ( empty($attr['ids']) ) return;
	$ids = explode(",", $attr['ids']);
	
	static $instance = 0;
	$instance++;
	$selector = "gallery-{$instance}";

	$output = "<div id=\"{$selector}\" class=\"gallery\">";
	$i = 0;
	$columns = 3;
	foreach ($ids as $id) {
		// $image_output = wp_get_attachment_link( (int)$id, 'post-thumbnail', false );
		$image_output = wp_get_attachment_image( (int)$id, 'thumbnail', false );	//post-thumbnail 特色图像尺寸
		$image_url = wp_get_attachment_url( (int)$id );
		$output .= "<a class=\"lightview thumb_wrap\" rel=\"{$selector}\" href=\"{$image_url}\" target=\"_blank\">{$image_output}</a>";
		if ( $columns > 0 && ++$i % $columns == 0 ) {
			$output .= '<br class="clear" />';
		}
	}
	$output .= "</div>";
	return $output;
}

//短代码[bimage]
add_shortcode('bimage', 'blueria_bimage_shortcode');
function blueria_bimage_shortcode( $attr ) {
	extract(shortcode_atts(array(
		'from' => 'in',
		'url' => '',
		'thumb' => '',
		'width' => '',
		'height' => '',
		'gif' => 0,
		'alt' => ''
	), $attr));
	if ( empty($url) ) return;

	$output = "";

	if ( $width <= 500 ) {
		$ratio_width = $width;
		$ratio_height = $height;
	} else {
		$ratio_width = 500;
		$ratio_height = intval(500 * $height / $width);
	}

	if ( $gif == 0 ) {		//不是gif动图直接输出
		global $post;
		$link = get_permalink( $post->ID );
		$limit_height = 500;	//限制高度
		if ( $limit_height > 0 && $ratio_height > $limit_height ) {	//如果有限制高度 并且图片高度超出限制的高度
			$diff = $ratio_height - $limit_height;	//高度差
			if ( !is_single() ) {
				if ( !wp_is_mobile() ) {
					$output .= "<div class=\"imagebox\" style=\"height: {$limit_height}px;\" data-diff=\"{$diff}\">";
					$output .= "<a class=\"zoom\" href=\"{$link}\" target=\"_blank\"><img class=\"pic\" src=\"{$url}\" alt=\"{$alt}\" /></a>";
					$output .= "<div class=\"image_more\" style=\"width: {$ratio_width}px;\"></div>";
					$output .= "</div>";
				} else {
					$output .= "<div class=\"imagebox\" style=\"height: 290px;\">";
					$output .= "<a class=\"zoom\" href=\"{$link}\" target=\"_blank\"><img class=\"pic\" src=\"{$url}\" alt=\"{$alt}\" /></a>";
					$output .= "<div class=\"image_more\" style=\"width: 100%;\"></div>";
					$output .= "</div>";
				}
			} else {
				$output .= "<div class=\"imagebox\" data-diff=\"{$diff}\">";
				$output .= "<a class=\"zoom minify\" href=\"javascript:;\"><img class=\"pic\" src=\"{$url}\" alt=\"{$alt}\" /></a>";
				$output .= "<div class=\"image_more\" style=\"width: {$ratio_width}px; display: none;\"></div>";
				$output .= "</div>";
			}
		} else { 	//否则:正常显示
			if ( !is_single() ) {
				$output .= "<div class=\"imagebox\">";
				$output .= "<a href=\"{$link}\" target=\"_blank\"><img class=\"pic\" src=\"{$url}\" alt=\"{$alt}\" /></a>";
				$output .= "</div>";
			} else {
				$output .= "<div class=\"imagebox\">";
				$output .= "<img class=\"pic\" src=\"{$url}\" alt=\"{$alt}\" />";
				$output .= "</div>";
			}
		}
	} else {
		$output .= "<div class=\"imagebox\">";
		$output .= "<a class=\"gif\" href=\"{$url}\" target=\"_blank\" rel=\"nofollow\"><img class=\"pic\" src=\"{$thumb}\" alt=\"{$alt}\" /></a>";
		$output .= "</div>";
	}

	return $output;
}

//短代码[bvideo]
add_shortcode('bvideo', 'blueria_bvideo_shortcode');
function blueria_bvideo_shortcode( $attr ) {
	extract(shortcode_atts(array(
		'type' => '',
		'vid' => '',
		'iid' => '',
		'code' => '',
		'lcode' => '',
		'img' => '',
		'thumb' => '',
		'url' => ''
	), $attr));
	if ( empty($type) || empty($vid) ) return;
	include_once dirname(__FILE__)."/inc/VideoPlayer.php";
	$player_url = VideoPlayer::url($type, $vid, $iid, $img, $url, $code, $lcode);
	if ( !wp_is_mobile() ) {
		global $post;
		$link = get_permalink( $post->ID );
		$FlashID = "Flash_".substr(md5($type.$vid), 8, 16);
		$link = is_single() ? 'javascript:;' : $link."#{$FlashID}";
		$output = "<div class=\"videobox\" data-id=\"{$FlashID}\" data-type=\"{$type}\" data-vid=\"{$vid}\" data-player=\"{$player_url}\">";
		$output .= "<div class=\"video_close\">收起视频</div>";
		$output .= "<div id='{$FlashID}'></div>";
		$output .= "<img class=\"pic\" src=\"{$img}\" alt=\"视频预览图\" />";
		$output .= "<a class=\"playbtn\" href=\"{$link}\" target=\"_blank\">播放</a>";
		$output .= "</div>";
	} else {
		$output = "<div class=\"videobox\">";
		$output .= $player_url;
		$output .= "</div>";
		if ( empty($player_url) ) $output = '<div class="Error">手机上 暂时无法播放这个视频</div>';
	}
	return $output;
}

//短代码[linkcat]
add_shortcode('linkcat','linkcat_shortcode');
function linkcat_shortcode($atts = null, $content = null) {
	$links = wp_list_bookmarks(array(
		'title_li' => '',
		'categorize' => 1,
		'category_name' => $content,
		'category_before' => '<div class="link_cat clearfix">', 'category_after' => '</div>',
		'title_before' => '<div class="title">', 'title_after' => '：</div>',
		'show_images' => 0,
		'orderby' => 'id',
		'hide_invisible' => 0,
		'echo' => 0
	));
	return $links;
}










//获取随机标签云
function blueria_randTagCloud($num, $_blank = false) {
	$tags = get_terms( 'post_tag', array( 'hide_empty' => 1, 'orderby' => 'rand', 'number' => $num ) );

	if ( $num == 0 ) {	//取所有标签 计算比率
		$counts = array();
		$real_counts = array();
		foreach ( $tags as $key => $tag ) {
			$real_counts[ $key ] = $tag->count;
			$counts[ $key ] = default_topic_count_scale( $tag->count );
		}
		$min_count = min( $counts );
		$spread = max( $counts ) - $min_count;
		$spread = $spread <= 0 ? 1 : $spread;
	}

	$randtags = "<ul class=\"rand_tags clearfix\">\n";
	foreach ( $tags as $key => $tag ) {
		$blank = $_blank ? 'target="_blank"' : '';
		$RG = array(rand(16,150), rand(180,220));
		shuffle($RG);
		$color = dechex($RG[0]<<16|$RG[1]<<8|0);
		$link = get_term_link( $tag );
		if( is_wp_error($link) ) continue;
		$name = $tag->name;
		$count = $tag->count;
		
		if ( $num == 0 ) {	//取所有标签时 只对部分着色
			$rate = ( $counts[$key] - $min_count ) / $spread;
			if ( $rate >= 0.75 ) {			//25%被着彩色
				$color = "color: #{$color};";
			} else if ( $rate >= 0.5 ) {	//50%被着灰蓝色
				$color = "color: #859DBA;";
			} else {	//剩下的默认
				$color = "";
			}
			$randtags .= "<li><a href=\"{$link}\" style=\"{$color}\" title=\"{$count}个话题\" {$blank}>{$name}</a></li>\n";
		} else {
			// $randtags .= "<li><a href=\"{$link}\" style=\"background-color: #{$color};\" title=\"{$count}个话题\" {$blank}>{$name}</a></li>\n";
			$randtags .= "<li><a href=\"{$link}\" style=\"color: #{$color};\" title=\"{$count}个话题\" {$blank}>{$name}</a></li>\n";
		}
	}
	$randtags .= "</ul>\n";
	return $randtags;
}









//投票功能
add_action('wp_ajax_blueria_vote', 'blueria_vote');
add_action('wp_ajax_nopriv_blueria_vote', 'blueria_vote');	//管理员未登录时
function blueria_vote() {
	global $wpdb;

	if ( !isset($_POST['post_ID']) || !isset($_POST['todo'])) exit( '0' );
	$post_ID = @$_POST['post_ID'] ? $_POST['post_ID'] : 0;
	if ( $post_ID == 0 ) exit( '-1' );
	if ( !get_post($post_ID) ) exit( '-1' );
	$todo = @$_POST['todo'];
	if ($todo != 'up' && $todo != 'down') exit( '-1' );

	if ($todo == 'up') {
		$vote = get_post_meta($post_ID, "blueria_vote", true);
		if( $vote != '') {
			$vote = (int)$vote + 1;
			update_post_meta($post_ID, "blueria_vote", $vote);
			setcookie("blueria_vote_" . $post_ID, $vote, time() + 3600*24, COOKIEPATH);
		} else {
			add_post_meta($post_ID, "blueria_vote", 1, true);
			setcookie("blueria_vote_" . $post_ID, 1, time() + 3600*24, COOKIEPATH);
		}
	} elseif ($todo == 'down') {
		$vote2 = get_post_meta($post_ID, "blueria_vote2", true);
		if( $vote2 != '') {
			$vote2 = (int)$vote2 - 1;
			update_post_meta($post_ID, "blueria_vote2", $vote2);
			setcookie("blueria_vote_" . $post_ID, $vote2, time() + 3600*24, COOKIEPATH);
		} else {
			add_post_meta($post_ID, "blueria_vote2", -1, true);
			setcookie("blueria_vote_" . $post_ID, -1, time() + 3600*24, COOKIEPATH);
		}
	}
	echo 'ok';

	exit();
}

//收藏功能
add_action('wp_ajax_blueria_like', 'blueria_like');
function blueria_like() {
	global $current_user;

	if ( !isset($_POST['post_ID']) ) exit( '0' );
	$post_ID = $_POST['post_ID'] ? intval($_POST['post_ID']) : 0;
	if ( $post_ID == 0 ) exit( '-1' );
	if ( !get_post($post_ID) ) exit( '-1' );

	$user_id = $current_user->ID;
	$posts = get_user_meta( $user_id, 'like_posts', true );	//如果不存在这个键返回的是空字符
	$liked = get_post_meta($post_ID, "blueria_liked", true);
	$liked = intval($liked);
	$result = '';
	if ( $posts == '' ) {
		$ok = add_user_meta( $user_id, 'like_posts', array($post_ID), true );
		if ( $ok ) {
			$result = 'liked';
			update_post_meta($post_ID, "blueria_liked", $liked + 1);
			setcookie("like_" . $post_ID, 1, time() + 3600*24*30, COOKIEPATH);
		}
	} else {
		if ( in_array($post_ID, $posts) ) {		//存在就删除
			$i = array_search($post_ID, $posts);
			unset($posts[$i]);	//删除索引位置的值
			$ok = update_user_meta( $user_id, 'like_posts', $posts );
			if ( $ok ) {
				$result = 'unliked';
				$liked = max(0, $liked - 1);
				update_post_meta($post_ID, "blueria_liked", $liked);
				setcookie("like_" . $post_ID, -1, time() - 1, COOKIEPATH);
			}
		} else {
			$posts[] = $post_ID;
			$ok = update_user_meta( $user_id, 'like_posts', $posts );
			if ( $ok ) {
				$result = 'liked';
				update_post_meta($post_ID, "blueria_liked", $liked + 1);
				setcookie("like_" . $post_ID, 1, time() + 3600*24*30, COOKIEPATH);
			}
		}
	}

	exit($result);
}

//已收藏
function liked() {
	global $post;
	$like = "";
	if ( is_user_logged_in() ) $like .= " enabled";
	if ( isset($_COOKIE['like_'.$post->ID]) && $_COOKIE['like_'.$post->ID] == '1' )  $like .= " liked";
	echo $like;
}









//评论列表
function blueria_theme_comments_list($comment, $args = array('avatar_size' => 36), $depth = 0, $stick = 0) {	//$stick是自定义的
	$GLOBALS['comment'] = $comment;
	extract($args, EXTR_SKIP);

	$floor = get_comment_meta( $comment->comment_ID, 'floor', true );
	$floor = $floor ? intval($floor) : 'n';
	$light = $comment->comment_karma;
	if ( $comment->comment_ID == @$args['blueria_lightest'] ) return;	//跳过置顶（最亮吐槽）
	$stick = $stick > 0 ? " stick" : "";	//是否是置顶的

	$currentTime = current_time('timestamp');
	$commentTime = get_comment_time('U');
	$timeDiff = $currentTime - $commentTime;
	if ($timeDiff <= 2592000) {
		$time_str = human_time_diff(get_comment_time('U'), current_time('timestamp'))."前";
	} else {
		$time_str = get_comment_time('Y/m/d H:i');
	}

	$html = "<li class=\"comment clearfix{$stick}\" id=\"comment-{$comment->comment_ID}\">";
		$html .= "<a class=\"avatarbox\" href=\"{$comment->comment_author_url}\" rel=\"reviewer nofollow\" target=\"_blank\">";
			$html .= get_avatar($comment, @$args['avatar_size']);
		$html .= "</a>";
		
		$html .= '<div class="info clearfix">';
			$html .= "<span class=\"floor right\">{$floor}楼</span>";
			if ( empty($comment->comment_author_url) ) 
				$html .= sprintf('<span id="reviewer-%d" class="reviewer" itemprop="author">%s</span>', $comment->comment_ID, $comment->comment_author);
			else
				$html .= sprintf('<a id="reviewer-%1$d" class="reviewer" href="%2$s" itemprop="author" rel="external nofollow" target="_blank">%3$s</a>', 
					$comment->comment_ID, $comment->comment_author_url, $comment->comment_author);
			$html .= sprintf('<time itemprop="datePublished" datetime="%1$s"><i class="i-clock-o"></i>%2$s</time>', get_comment_time('Y-m-d\TH:i'), $time_str);
		$html .= '</div>';
		
		$html .= "<div class=\"content\" id=\"commentbody-{$comment->comment_ID}\" itemprop=\"description\">";
			$html .= ($comment->comment_approved == '0') ? "<p style='color:#FF5555;'>你的吐槽需要审核后才能显示 ...</p>" : wpautop($comment->comment_content);
		$html .= '</div>';

		$html .= "<div class=\"comment-act\"><a class=\"light\" href=\"javascript:;\"><i class=\"i-lightbulb-o\"></i>亮了(<span>{$light}</span>)</a><a class=\"respond\" href=\"#respond\">回复</a></div>";
		if ( !empty($stick) ) $html .= '<div class="light_title">最亮吐槽</div>';
	// $html .= "</li>";	//郁闷 这是自动追加的吗
	echo $html;
}


//评论时 设置楼层
add_action('wp_insert_comment','blueria_comment_inserted', 99, 2);
function blueria_comment_inserted($comment_id, $comment_object) {
	$post_ID = $comment_object->comment_post_ID;
	$floor = (string) get_post_meta( $post_ID, "comment_floor", true );	//当前楼层排位
	if ( empty($floor) ) {
		add_comment_meta( $comment_id, 'floor', '1' );
		add_post_meta( $post_ID, 'comment_floor', '1' );
	} else {
		$floor = intval($floor) + 1;
		update_comment_meta( $comment_id, 'floor', $floor );
		update_post_meta( $post_ID, 'comment_floor', $floor );
	}
}

//评论点亮
add_action('wp_ajax_blueria_light', 'blueria_light');
add_action('wp_ajax_nopriv_blueria_light', 'blueria_light');	//管理员未登录时
function blueria_light() {
	if ( !isset($_POST['comment_ID']) || !preg_match("/^comment\-(\d+)$/", $_POST['comment_ID'], $matches) ) exit( '0' );
	$comment_ID = intval($matches[1]);
	$comment = get_comment( $comment_ID );
	if ( !$comment ) exit('-1');

	$new_karma = intval($comment->comment_karma) + 1;
	$ok = wp_update_comment(array(
		'comment_ID' => $comment_ID,
		'comment_karma' => $new_karma
	));
	if ( $ok ) {
		setcookie("blueria_light_" . $_POST['comment_ID'], 1, time() + 3600*24, COOKIEPATH);
		exit('ok');
	} else {
		exit('0');
	}
}

//ajax获取一条评论
add_action('wp_ajax_blueria_load_comment', 'blueria_load_comment');
add_action('wp_ajax_nopriv_blueria_load_comment', 'blueria_load_comment');	//管理员未登录时
function blueria_load_comment() {
	if ( !isset($_POST['comment_ID']) || !isset($_POST['post_ID']) ) exit( '0' );
	$comment_ID = intval($_POST['comment_ID']);
	$post_ID = intval($_POST['post_ID']);
	if ( $comment_ID <= 0 || $post_ID <= 0 ) exit('0');

	$comment = get_comment( $comment_ID );
	if ( !$comment ) exit('-1');
	if ( $comment->comment_post_ID != $post_ID ) exit('-1');	//验证是否是对应post下的评论

	blueria_theme_comments_list( $comment );
	exit();
}

//验证码
add_action('wp_ajax_blueria_code', 'blueria_code');
add_action('wp_ajax_nopriv_blueria_code', 'blueria_code');
function blueria_code() {
	if ( !isset($_POST['code']) ) exit( '0' );
	$code = strtolower(trim($_POST['code']));
	if ( $_SESSION['code'] == $code ) {
		exit('yes');
	} else {
		exit('no');
	}
}








//调整文章管理页列顺序和名称
add_filter('manage_posts_columns', 'blueria_manage_posts_columns');
function blueria_manage_posts_columns( $columns ) {
	$columns['categories'] = "分类";
	isset($columns['views']) && $columns['views'] = "浏览";
	unset($columns['date']);	//去掉"日期"
	$columns['date'] = "日期";	//再加上去
	return $columns;
}



//快速置顶
add_filter( 'manage_posts_columns', 'blueria_posts_columns' );
add_action( 'manage_posts_custom_column', 'blueria_posts_custom_column', 10, 3 );
function blueria_posts_columns( $columns ) {
	$columns['sticky'] = '置顶';
	unset($columns['date']);	//去掉"日期"
	$columns['date'] = "日期";	//再加上去
	return $columns;
}
function blueria_posts_custom_column( $column, $post_id ) {
	if ( 'sticky' == $column ) {
		if ( is_sticky($post_id) ) {
			$value = "<span class='sticky_btn dashicons dashicons-star-filled' data-id='{$post_id}'></span>";
		} else {
			$value = "<span class='sticky_btn dashicons dashicons-star-empty' data-id='{$post_id}'></span>";
		}
	}
	echo $value;
}
//切换置顶
add_action('wp_ajax_blueria_sticky_setting', 'blueria_sticky_setting');
function blueria_sticky_setting() {
	if ( !current_user_can('manage_options') ) die('-1');

	if ( empty($_POST['sticky']) || empty($_POST['post_id']) ) die('0');
	$sticky = $_POST['sticky'];
	$post_ID = intval($_POST['post_id']);
	if ( $sticky != 'yes' && $sticky != 'no' ) die('0');

	$stickies = get_option('sticky_posts');
	if ( !is_array($stickies) ) $stickies = array();

	if ( in_array($post_ID, $stickies) ) {
		if ( $sticky == 'no' ) {
			$i = array_search($post_ID, $stickies);
			unset($stickies[$i]);
			$ok = update_option('sticky_posts', $stickies);
			if ( !$ok ) die('0');
		}
	} else {
		if ( $sticky == 'yes' ) {
			array_unshift($stickies, $post_ID);
			$ok = update_option('sticky_posts', $stickies);
			if ( !$ok ) die('0');
		}
	}

	die('ok');
}



//设置用户 投稿免审
add_filter( 'manage_users_columns', 'blueria_users_columns' );
add_action( 'manage_users_custom_column', 'blueria_users_custom_column', 10, 3 );
function blueria_users_columns( $columns ) {
	$columns['tougao_mianshen'] = '投稿免审';
	return $columns;
}
function blueria_users_custom_column( $value, $column_name, $user_id ) {
	if ( 'tougao_mianshen' == $column_name ) {
		$user = get_user_by( 'id', $user_id );
		if ( $user->has_cap('publish_posts') ) {
			$value = "<span class='dashicons dashicons-yes'></span>";
		} else if ( $user->has_cap('tougao_mianshen') ) {
			$value = "<span class='mianshen_btn dashicons dashicons-star-filled' data-userid='{$user_id}'></span>";
		} else {
			$value = "<span class='mianshen_btn dashicons dashicons-star-empty' data-userid='{$user_id}'></span>";
		}
	}
	return $value;
}
//切换免审权限
add_action('wp_ajax_blueria_mianshen_setting', 'blueria_mianshen_setting');
function blueria_mianshen_setting() {
	if ( !current_user_can('edit_users') ) die('-1');

	if ( empty($_POST['mianshen']) || empty($_POST['userid']) ) die('0');
	$mianshen = $_POST['mianshen'];
	$user_id = intval($_POST['userid']);
	if ( $mianshen != 'yes' && $mianshen != 'no' ) die('0');

	$user = get_user_by( 'id', $user_id );
	if ( $mianshen == 'yes' ) {
		$user->add_cap('tougao_mianshen');
	} else {
		$user->remove_cap('tougao_mianshen');
	}
	die('ok');
}







//生成新的css样式表
add_action('wp_ajax_blueria_lesscss', 'blueria_generate_lesscss');
function blueria_generate_lesscss() {
	if ( !current_user_can('manage_options') ) die('-2');

	$modi = array();
	$ui_style = get_option('ui_style', blueria_get_option('ui_style')); 
	if ( intval($ui_style['head_height']) >= 0 ) $modi['head_height'] = intval(@$ui_style['head_height']).'px';
	if ( !empty($ui_style['head_bg_img']) ) $modi['head_bg_img'] = $ui_style['head_bg_img'];
	if ( !empty($ui_style['head_bg_color']) ) $modi['head_bg_color'] = $ui_style['head_bg_color'];
	if ( intval($ui_style['logo_top']) >= 0 ) $modi['logo_top'] = intval(@$ui_style['logo_top']).'px';
	if ( !empty($ui_style['nav_logo']) ) $modi['nav_logo'] = $ui_style['nav_logo'];
	if ( intval($ui_style['nav_logo_width']) > 0 ) $modi['nav_logo_width'] = intval(@$ui_style['nav_logo_width']).'px';
	if ( intval($ui_style['nav_logo_height']) > 0 ) $modi['nav_logo_height'] = intval(@$ui_style['nav_logo_height']).'px';
	if ( intval($ui_style['nav_logo_right']) > 0 ) $modi['nav_logo_right'] = intval(@$ui_style['nav_logo_right']).'px';
	if ( intval($ui_style['nav_height']) > 0 ) $modi['navbar_height'] = intval(@$ui_style['nav_height']).'px';
	if ( !empty($ui_style['nav_bg_color']) ) $modi['nav_bg_color'] = $ui_style['nav_bg_color'];
	if ( !empty($ui_style['bg']) ) $modi['main_bg'] = $ui_style['bg'];
	if ( !empty($ui_style['bright_color_1']) ) $modi['ui-bright-color-1'] = $ui_style['bright_color_1'];
	if ( !empty($ui_style['bright_color_2']) ) $modi['ui-bright-color-2'] = $ui_style['bright_color_2'];
	if ( !empty($ui_style['bright_color_3']) ) $modi['ui-bright-color-3'] = $ui_style['bright_color_3'];
	if ( !empty($ui_style['dark_color_1']) ) $modi['ui-dark-color-1'] = $ui_style['dark_color_1'];
	if ( !empty($ui_style['dark_color_2']) ) $modi['ui-dark-color-2'] = $ui_style['dark_color_2'];
	if ( floatval($ui_style['shadow_alpha']) >= 0 ) $modi['ui-shadow-alpha'] = floatval(@$ui_style['shadow_alpha']);
	if ( !empty($ui_style['widget_bg_color']) ) $modi['widget_bg_color'] = $ui_style['widget_bg_color'];
	if ( !empty($ui_style['foot_bg']) ) $modi['foot_bg'] = $ui_style['foot_bg'];
	if ( !empty($ui_style['sep_line_1']) ) $modi['sep_line_1'] = $ui_style['sep_line_1'];
	if ( !empty($ui_style['sep_line_2']) ) $modi['sep_line_2'] = $ui_style['sep_line_2'];
	if ( isset($ui_style['first_letter_zoom']) ) $modi['first_letter_zoom'] = 0;

	include_once dirname(__FILE__).'/inc/less/Less.php';
	ini_set("memory_limit", "80M");
	$less = new Less_Parser(array( 'compress' => true ));
	$less->parseFile( dirname(__FILE__).'/global.less' );
	$less->ModifyVars( $modi );
	$css = $less->getCss();
	$ok = file_put_contents( dirname(__FILE__).'/global.css', $css );
	if ($ok) die('ok');
	else die('-1');
}







//重新设置缩略图尺寸
function blueria_reset_image_display_settings() {
	update_option('thumbnail_size_w', '160');
	update_option('thumbnail_size_h', '120');
	update_option('thumbnail_crop', '1');	//总是裁剪
	update_option('medium_size_w', '0');
	update_option('medium_size_h', '0');	//不需要中等尺寸的图 占用存储空间
	update_option('large_size_w', '500');
	update_option('large_size_h', '0');
	
	update_option( 'image_default_align', 'left' );			//left right center none
	update_option( 'image_default_link_type', 'none' );		//file post custom none
	update_option( 'image_default_size', 'large' );			//thumbnail medium large full
}

//主题初始化
add_action('after_switch_theme', 'blueria_theme_init');
function blueria_theme_init() {
	$t = get_option('template');
	if ( get_option($t.'_theme_inited') ) return;
	add_option($t.'_theme_inited', '1');

	blueria_add_page('快捷投稿', 'tougao', 'page-tougao.php');
	blueria_add_page('手气不错', 'random', 'page-random.php');
	blueria_add_page('所有标签', 'tags', 'page-tags.php');
	blueria_add_page('所有专题', 'topics', 'page-topics.php');
	blueria_add_page('用户中心', 'member', 'page-member.php');

	blueria_reset_image_display_settings();
}