<?php
/**
 *	各大视频播放器地址
 *	临时的一个类
 */
class VideoPlayer {
	private static $BPlayer;
	/**
	 *	获取播放器地址
	 *	@param string $type	视频网站类型
	 *	@param string $vid	视频id
	 *	@param string $url	引用页地址
	 */
	public static function url($type, $vid, $iid, $img, $url, $code, $lcode) {
		$HOST = $_SERVER['HTTP_HOST'];
		self::$BPlayer = preg_replace("#http:\/\/[^\/]+\/#", "http://{$HOST}/", get_bloginfo('template_url')."/api/BPlayer.swf");
		switch ($type) {
			case 'sina'		: return self::sinaPlayer($vid, $iid, $img);
			case 'qq'		: return self::qqPlayer($vid);
			case 'youku'	: return self::youkuPlayer($vid);
			case 'tudou'	: return self::tudouPlayer($vid, $url, $code, $lcode);
			case 'pptv'		: return self::pptvPlayer($vid);
			case '56'		: return self::_56Player($vid);
			case 'ku6'		: return self::ku6Player($vid, $img);
			case 'sohu'		: return self::sohuPlayer($vid, $img);
			case 'sohu-my'	: return self::sohuPlayer($vid, $img, true);
		}
	}

	private static function sinaPlayer($vid, $iid, $img) {
		if ( wp_is_mobile() ) return "<video width='100%' height='100%' poster='{$img}' controls='controls' preload='' src='http://video.proc.sina.cn/video_explore/location.php?vid={$vid}&video_id={$iid}'></video>";
		return self::$BPlayer;
		// return "http://you.video.sina.com.cn/api/sinawebApi/outplayrefer.php/vid={$vid}_0/s.swf?autoPlay=1";
	}

	private static function qqPlayer($vid) {
		if ( wp_is_mobile() ) return "<iframe src=\"http://v.qq.com/iframe/player.html?vid={$vid}&tiny=0&auto=0\" frameborder=\"0\" allowfullscreen></iframe>";
		return self::$BPlayer;
		// return "http://static.video.qq.com/TPout.swf?vid={$vid}";
	}

	private static function youkuPlayer($vid) {
		if ( wp_is_mobile() ) return "<iframe src=\"http://player.youku.com/embed/{$vid}\" frameborder=\"0\" allowfullscreen></iframe>";
		return "http://player.youku.com/player.php/sid/{$vid}/v.swf";
	}

	private static function tudouPlayer($vid, $url, $code, $lcode) {
		if ( wp_is_mobile() ) {
			return "<iframe src=\"http://www.tudou.com/programs/view/html5embed.action?code={$code}&lcode={$lcode}\" frameborder=\"0\" allowfullscreen></iframe>";
		}
		if ( preg_match("#\/v(iew)?\/([\w\-]+)\/#", $url, $matches) ) {
			return "http://www.tudou.com/v/{$matches[2]}/v.swf";
		} elseif ( preg_match("#\/l(istplay)?\/([\w\-]+)#", $url, $matches) ) {
			return "http://www.tudou.com/l/{$matches[2]}/&iid={$vid}/v.swf";
		} elseif ( preg_match("#\/a(lbumplay)?\/([\w\-]+)#", $url, $matches) ) {
			return "http://www.tudou.com/a/{$matches[2]}/&iid={$vid}/v.swf";
		} else {
			return self::$BPlayer;
		}
	}

	private static function pptvPlayer($vid) {
		if ( wp_is_mobile() ) return "";	//17479287
		//http://web-play.pptv.com/webplay3-0-17479287.xml?version=4&type=mpptv&kk=9e7d14664ca37e599611f9cc1bd3c428-e431-53ed0d40
		//http://web-play.pptv.com/webplay3-0-17479287.xml?version=4&type=m3u8.web.pad&cb=pptv_cb
		return "http://player.pptv.com/v/{$vid}.swf";
	}

	private static function _56Player($vid) {
		if ( wp_is_mobile() ) return "<iframe src=\"http://www.56.com/iframe/{$vid}\" frameborder=\"0\" allowfullscreen></iframe>";
		return "http://player.56.com/v_{$vid}.swf";
	}

	private static function ku6Player($vid, $img) {
		if ( wp_is_mobile() ) return "<video width='100%' height='100%' poster='{$img}' controls='controls' preload='' src='http://v.ku6.com/fetchwebm/{$vid}.m3u8'></video>";
		return "http://player.ku6.com/refer/{$vid}/v.swf";
	}

	private static function sohuPlayer($vid, $img, $my = false) {
		if ( wp_is_mobile() ) {
			if ( $my ) return "<video width='100%' height='100%' poster='{$img}' controls='controls' preload='' src='http://my.tv.sohu.com/ipad/{$vid}.m3u8'></video>";
			//http://my.tv.sohu.com/ipad/h72645688_4619361690713_04758899.m3u8?vid=72645688	(最新 有待研究)
			return "<video width='100%' height='100%' poster='{$img}' controls='controls' preload='' src='http://hot.vrs.sohu.com/ipad{$vid}_123_456.m3u8?vid={$vid}'></video>";
			//http://hot.vrs.sohu.com/ipad1185802_4619361835297_4396123.m3u8?vid=1185802	(最新 有待研究 迫于无奈在后面加了_123_456 竟然可以 卧槽)
		}
		if ( $my ) return "http://share.vrs.sohu.com/my/v.swf&id={$vid}";
		return "http://share.vrs.sohu.com/{$vid}/v.swf";
	}
}