<?php


class Blueria_Widget_Visitors extends WP_Widget {
	function __construct() {
		$widget_ops = array('classname'=>'widget_visitors','description'=>'基于多说脚本 到网站设置里设置一下');
		parent::__construct(false, '最近访客', $widget_ops);
	}

	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$row = isset($instance['row']) ? absint($instance['row']) : 1;
		$title_field_id = $this->get_field_id('title');
		$title_field_name = $this->get_field_name('title');
		echo "<p><label for='{$title_field_id}'>显示标题:</label><input id='{$title_field_id}' name='{$title_field_name}' type='text' value='{$title}' style='width:100%;' /></p>";
		echo "<p>显示<input name='".$this->get_field_name('row')."' type='text' value='{$row}' style='width:25px;' />行最近访客</p>";
	}

	function widget( $args, $instance ) {
		extract( $args );
		$title = empty( $instance['title'] ) ? '最近访客' : $instance['title'];
		$row = $instance['row'] ? $instance['row'] : 1;
		$visitor_num = $row * 6;
		$div_height = $row * 46;
		
		echo $before_widget;
		echo $before_title . $title . $after_title;
		echo "<div class='ds-recent-visitors clearfix' data-num-items='{$visitor_num}' data-avatar-size='32' style='height:{$div_height}px;'></div>";
		echo $after_widget;
	}
}


class Blueria_Widget_Rising extends WP_Widget {
	function __construct() {
		$widget_ops = array('classname'=>'widget_posts_recommend', 'description'=>'显示近期人气最高的文章');
		parent::__construct(false, '人气趋势', $widget_ops);
	}

	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$number = isset($instance['number']) ? absint($instance['number']) : 5;
		$title_field_id = $this->get_field_id('title');
		$title_field_name = $this->get_field_name('title');
		$number_field_id = $this->get_field_id('number');
		$number_field_name = $this->get_field_name('number');
		echo "<p><label for='{$title_field_id}'>显示标题: <input type='text' id='{$title_field_id}' name='{$title_field_name}' value='{$title}' style='width:100%;' /></label></p>";
		echo "<p><label for='{$number_field_id}'>显示文章数: <input type='text' id='{$number_field_id}' name='{$number_field_name}' value='{$number}' /></label></p>";
		$only_title = isset($instance['only_title']) ? $instance['only_title'] : "";
		echo "<p><label><input type='checkbox' name=".$this->get_field_name('only_title')." ".checked( 'on', $only_title, false )." />仅显示标题(不显示缩略图)</label></p>";
	}

	private $last_day = 0;
	function filter_where( $where = '' ) {
		$where .= " AND TO_DAYS('{$this->last_day}') - TO_DAYS(post_date) <= 7 ";	//最后7天
		return $where;
	}
	function widget( $args, $instance ) {
		extract( $args );
		$num = isset($instance['number']) ? $instance['number'] : 5;
		$title = empty( $instance['title'] ) ? '人气趋势' : $instance['title'];
		$only_title = isset($instance['only_title']) ? 1 : 0;

		global $wpdb;
		$last_day = $wpdb->get_var("SELECT post_date FROM $wpdb->posts WHERE post_type = 'post' AND post_status = 'publish' AND post_password = '' ORDER BY post_date DESC LIMIT 1");
		$this->last_day = $last_day ? $last_day : date("Y-m-d H:i:s");	//如果获取失败就设置为今天

		$query_array = array(
			'paged' => 1,
			'posts_per_page' => $num,
			'category_name' => 'video,image',
			'orderby' => 'meta_value_num', 
			'meta_key' => 'views'
		);
		add_filter( 'posts_where', array($this, 'filter_where') );
		$most_viewed_query = new WP_Query( $query_array );
		$most_viewed = $most_viewed_query->posts;
		remove_filter( 'posts_where', array($this, 'filter_where') );

		if ( $most_viewed ) {
			shuffle($most_viewed);	//将数组元素随机排列一下
			echo $before_widget;
			echo $before_title . $title . $after_title;
			echo '<div class="items clearfix">';
			foreach ($most_viewed as $post) {
				$thumb = get_the_post_thumbnail($post->ID);

				$title = strip_tags($post->post_title);

				$url = get_permalink($post);
				if ( $only_title ) {
					echo "<h3><a href=\"{$url}\">{$title}</a></h3>";
				} else {
					echo "<dl class='clearfix'>";
					echo "<dt><a class=\"thumb_wrap\" href=\"{$url}\" title=\"{$title}\" rel=\"nofollow\">{$thumb}</a>";
					echo "<h3><a href=\"{$url}\">{$title}</a></h3></dt>";
					echo "</dl>";
				}
			}
			echo '</div>';
			echo $after_widget;
		}
	}
}



class Blueria_Widget_Recommend extends WP_Widget {
	function __construct() {
		$widget_ops = array('classname'=>'widget_posts_recommend', 'description'=>'推荐1个月内点赞最多的文章');
		parent::__construct(false, '诚意推荐', $widget_ops);
	}

	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$number = isset($instance['number']) ? absint($instance['number']) : 5;
		$title_field_id = $this->get_field_id('title');
		$title_field_name = $this->get_field_name('title');
		$number_field_id = $this->get_field_id('number');
		$number_field_name = $this->get_field_name('number');
		echo "<p><label for='{$title_field_id}'>显示标题: <input type='text' id='{$title_field_id}' name='{$title_field_name}' value='{$title}' style='width:100%;' /></label></p>";
		echo "<p><label for='{$number_field_id}'>显示文章数: <input type='text' id='{$number_field_id}' name='{$number_field_name}' value='{$number}' style='width:95px;' /> ≤15篇</label></p>";
		$only_title = isset($instance['only_title']) ? $instance['only_title'] : "";
		echo "<p><label><input type='checkbox' name=".$this->get_field_name('only_title')." ".checked( 'on', $only_title, false )." />仅显示标题(不显示缩略图)</label></p>";
	}

	function widget( $args, $instance ) {
		extract( $args );
		$num = isset($instance['number']) ? $instance['number'] : 5;
		$title = empty( $instance['title'] ) ? '诚意推荐' : $instance['title'];
		$only_title = isset($instance['only_title']) ? 1 : 0;


		$date_query = array(
			array('column' => 'post_date', 'after' => '1 month ago')	//一个月内
		);
		$query_array = array(
			'paged' => 1,
			'posts_per_page' => 30,
			'category_name' => 'video,image',
			'date_query' => $date_query,
			'orderby' => 'meta_value_num',
			'meta_key' => 'blueria_vote'
		);
		$most_up_query = new WP_Query( $query_array );
		$most_up = $most_up_query->posts;

		if ( $most_up ) {
			shuffle($most_up);	//将数组元素随机排列一下
			echo $before_widget;
			echo $before_title . $title . $after_title;
			echo '<div class="items clearfix">';
			$count = 1;	//计数器
			foreach ($most_up as $post) {
				$thumb = get_the_post_thumbnail($post->ID);

				$title = strip_tags($post->post_title);

				$url = get_permalink($post);
				if ( $only_title ) {
					echo "<h3><a href=\"{$url}\">{$title}</a></h3>";
				} else {
					echo "<dl class='clearfix'>";
					echo "<dt><a class=\"thumb_wrap\" href=\"{$url}\" title=\"{$title}\" rel=\"nofollow\">{$thumb}</a>";
					echo "<h3><a href=\"{$url}\">{$title}</a></h3></dt>";
					echo "</dl>";
				}

				$count ++;
				if ($count > $num) break;	//显示前$num篇即可
			}
			echo '</div>';
			echo $after_widget;
		}
	}
}


class Blueria_Widget_OldPosts extends WP_Widget {
	function __construct() {
		$widget_ops = array('classname'=>'widget_posts_recommend', 'description'=>'随机显示早期的文章');
		parent::__construct(false, '随机推荐', $widget_ops);
	}

	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$number = isset($instance['number']) ? absint($instance['number']) : 6;
		$ago = isset($instance['ago']) ? absint($instance['ago']) : 7;
		$title_field_id = $this->get_field_id('title');
		$title_field_name = $this->get_field_name('title');
		$number_field_id = $this->get_field_id('number');
		$number_field_name = $this->get_field_name('number');
		$ago_field_id = $this->get_field_id('ago');
		$ago_field_name = $this->get_field_name('ago');
		echo "<p><label for='{$title_field_id}'>显示标题: <input type='text' id='{$title_field_id}' name='{$title_field_name}' value='{$title}' style='width:100%;' /></label></p>";
		echo "<p><label for='{$ago_field_id}'>随机显示<input type='text' id='{$ago_field_id}' name='{$ago_field_name}' value='{$ago}' style='width:25px;' />天前的文章</label></p>";
		echo "<p><label for='{$number_field_id}'>显示文章数: <input type='text' id='{$number_field_id}' name='{$number_field_name}' value='{$number}' style='width:95px;' /></label></p>";
		$only_title = isset($instance['only_title']) ? $instance['only_title'] : "";
		echo "<p><label><input type='checkbox' name=".$this->get_field_name('only_title')." ".checked( 'on', $only_title, false )." />仅显示标题(不显示缩略图)</label></p>";
	}

	function widget( $args, $instance ) {
		extract( $args );
		$title = isset( $instance['title'] ) && !empty($instance['title']) ? $instance['title'] : '随机推荐';
		$num = isset($instance['number']) ? $instance['number'] : 6;
		$ago = isset($instance['ago']) ? $instance['ago'] : 7;
		$only_title = isset($instance['only_title']) ? 1 : 0;


		$date_query = array(
			array('column' => 'post_date', 'before' => "{$ago} day ago")	//n天前
		);
		$query_array = array(
			'paged' => 1,
			'posts_per_page' => $num,
			'category_name' => 'video,image',
			'date_query' => $date_query,
			'orderby' => 'rand'
		);
		$old_posts_query = new WP_Query( $query_array );
		$old_posts = $old_posts_query->posts;
		
		if ( $old_posts ) {
			echo $before_widget;
			echo $before_title . $title . $after_title;
			echo '<div class="items clearfix">';
			foreach ($old_posts as $post) {
				$thumb = get_the_post_thumbnail($post->ID);

				$title = strip_tags($post->post_title);

				$url = get_permalink($post);
				if ( $only_title ) {
					echo "<h3><a href=\"{$url}\">{$title}</a></h3>";
				} else {
					echo "<dl class='clearfix'>";
					echo "<dt><a class=\"thumb_wrap\" href=\"{$url}\" title=\"{$title}\" rel=\"nofollow\">{$thumb}</a>";
					echo "<h3><a href=\"{$url}\">{$title}</a></h3></dt>";
					echo "</dl>";
				}
			}
			echo '</div>';
			echo $after_widget;
		}
	}
}


class Blueria_Widget_Follow extends WP_Widget {
	function __construct() {
		$widget_ops = array('classname'=>'widget_follow_wrap','description'=>'此分隔条下方的小工具都会被浮动');
		parent::__construct(false, '浮动分隔条', $widget_ops);
	}

	function form( $instance ) {
		echo "<p>这个分隔条下方的小工具都有浮动效果</p>";
		echo "<p>特别提醒 每个栏位只能使用一个浮动分隔条</p>";
	}

	function widget( $args, $instance ) {
		echo "<li class='followBlock'><ul class='widgets_wrap'>";
	}
}
//自动补全浮动包裹
add_action('dynamic_sidebar_after', 'blueria_follow_widget_handler');
function blueria_follow_widget_handler( $sidebar_name ) {
	if ( is_admin() ) return;
	$sidebars_widgets = wp_get_sidebars_widgets();
	if ( empty($sidebars_widgets[$sidebar_name]) ) return;
	foreach ($sidebars_widgets[$sidebar_name] as $widget_id) {
		if ( preg_match("/^blueria_follow\-/", $widget_id) ) {
			echo "</ul></li>";
			break;
		}
	}
}



class Blueria_widget_RichText extends WP_Widget {
	function __construct() {
		$widget_ops = array('classname'=>'widget_richtext', 'description'=>'强化原来的[文本]小工具');
		$control_ops = array('width'=>400, 'height'=>300);
		parent::__construct(false, '富文本', $widget_ops, $control_ops);
	}
	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => '这个小工具是做什么的', 'showtitle' => '', 'code' => '', 'class' => '', 'radius' => '', 'style' => '' ) );
		$title = strip_tags($instance['title']);
		$showtitle = $instance['showtitle'];
		$code = esc_textarea($instance['code']);
		$class = strip_tags($instance['class']);
		$radius = strip_tags($instance['radius']);
		$style = strip_tags($instance['style']);
		echo "<p><label>用途：<input class='widefat' id='{$this->get_field_id('title')}' name=".$this->get_field_name('title')." type='text' value='{$title}' /></label></p>";
		echo "<p><label>显示标题：<input class='widefat' name=".$this->get_field_name('showtitle')." type='text' value='{$showtitle}' /></label></p>";
		echo "<textarea name=\"{$this->get_field_name('code')}\" rows=\"6\" style='width:100%;max-width:100%'>{$code}</textarea>";
		echo "<p>";
		echo "<label>class：<input class='widefat' name=".$this->get_field_name('class')." type='text' value='{$class}' style='width:100px' /></label>";
		echo "<label style='margin-left: 15px;'><input type='checkbox' name=".$this->get_field_name('radius')." ".checked( 'on', $radius, false )." />显示为圆角</label>";
		echo "</p>";
		echo "<p><label>style = <input class='widefat' name=".$this->get_field_name('style')." type='text' value='{$style}' style='width:80%' placeholder='CSS行样式' /></label></p>";
	}
	function widget( $args, $instance ) {
		extract( $args );
		$title = isset( $instance['showtitle'] ) ? $instance['showtitle'] : '';
		$code = $instance['code'] ? $instance['code'] : '';
		$class = isset( $instance['class'] ) ? $instance['class'] : '';
		$radius = isset( $instance['radius'] ) ? $instance['radius'] : '';
		$style = isset( $instance['style'] ) ? $instance['style'] : '';

		$code = do_shortcode( $code );
		$radius = $radius == 'on' ? " radius" : "";
		$style = $style ? "{$style}" : "";
		$class = !empty($class) ? ' '.$class : '';
		
		if ( !empty( $title ) ) { 
			echo "<li class='widget widget_richtext{$class}{$radius}'>";
			echo $before_title . $title . $after_title;
			echo "<div class='textwidget{$class}{$radius}' style='{$style}'>{$code}</div>";
			echo "</li>";
		} else {
			echo "<li class='widget_richtext{$class}{$radius}'>{$code}</li>";
		}
	}
}



class Blueria_Widget_RandTagCloud extends WP_Widget {
	function __construct() {
		$widget_ops = array('classname'=>'widget_randtagcloud','description'=>'随机显示标签云');
		parent::__construct(false, '随机标签云', $widget_ops);
	}

	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$num = isset($instance['num']) ? absint($instance['num']) : 30;
		$_blank = isset($instance['blank']) ? esc_attr($instance['blank']) : '';
		$title_field_id = $this->get_field_id('title');
		$title_field_name = $this->get_field_name('title');
		echo "<p><label for='{$title_field_id}'>显示标题：</label><input id='{$title_field_id}' name='{$title_field_name}' type='text' value='{$title}' style='width:100%;' /></p>";
		echo "<p><label>显示<input name='".$this->get_field_name('num')."' type='text' value='{$num}' style='width:30px;' />个标签</label></p>";
		echo "<p><label><input type='checkbox' name='".$this->get_field_name('blank')."' ".checked( 'on', $_blank, false )." />在新窗口打开标签</label></p>";
	}

	function widget( $args, $instance ) {
		extract( $args );
		$title = !empty( $instance['title'] ) ? $instance['title'] : '标签云';
		$num = ((int)$instance['num'] > 0) ? absint($instance['num']) : 30;
		$_blank = isset($instance['blank']) ? true : false;
		$_b = $_blank + 0;
		
		echo $before_widget;
		echo $before_title . $title . $after_title;
		echo "<a href=\"javascript:;\" class=\"change_btn\" data-action=\"num={$num}&blank={$_b}\"><i class=\"i-refresh\"></i>换一换</a>";
		echo blueria_randTagCloud($num, $_blank);
		echo '<div class="all_tags"><a href="'.blueria_get_page_link('tags').'" target="_blank">查看所有</a></div>';
		echo $after_widget;
	}
}
//随机标签云[换一换]
add_action('wp_ajax_change_tagcloud', 'blueria_change_tagcloud');
add_action('wp_ajax_nopriv_change_tagcloud', 'blueria_change_tagcloud');
function blueria_change_tagcloud() {
	if ( !isset($_POST['num']) || !isset($_POST['blank']) ) exit('0');
	$num = (int)$_POST['num'];
	$blank = (int)$_POST['blank'];
	echo blueria_randTagCloud($num, $blank);
	exit();
}





add_action('widgets_init', 'blueria_widget_init');
function blueria_widget_init() {
	register_widget('Blueria_Widget_Visitors');
	register_widget('Blueria_Widget_Rising');
	register_widget('Blueria_Widget_Recommend');
	register_widget('Blueria_Widget_OldPosts');
	register_widget('Blueria_Widget_Follow');
	register_widget('Blueria_widget_RichText');
	register_widget('Blueria_Widget_RandTagCloud');
	unregister_widget('WP_Widget_Calendar');	//日历
	unregister_widget('WP_Widget_RSS');
	unregister_widget('WP_Widget_Search');
	unregister_widget('WP_Widget_Links');
	unregister_widget('WP_Widget_Pages');
	unregister_widget('WP_Widget_Archives');	//归档
	unregister_widget('WP_Widget_Categories');
	unregister_widget('WP_Widget_Recent_Posts');
	unregister_widget('WP_Widget_Recent_Comments');
	unregister_widget('WP_Widget_Tag_Cloud');
	unregister_widget('WP_Nav_Menu_Widget');
	unregister_widget('WP_Widget_Meta');		//功能
	unregister_widget('WP_Widget_Text');
	unregister_widget('WP_Widget_PostViews');
}