<?php
/*
 *	Template Name: 用户中心
 */
if ( !defined('ABSPATH') ) {
	header('HTTP/1.0 403 Forbidden');
	exit();
}

if ( !is_user_logged_in() ) {
	wp_redirect( home_url() );
	exit;
}

$current_user = wp_get_current_user();

if ( !empty($_POST['nicename']) ) {
	//验证nonce
	if ( !isset($_POST['blueria_nonce']) || !wp_verify_nonce($_POST['blueria_nonce'], 'blueria') ) {
		wp_die("非法操作！");
	}

	$email = trim( $_POST['email'] );
	$email = preg_match("/^([a-z0-9]+[\-\_\.]?)*[a-z0-9]+@([a-z0-9]+[\-\_\.]?)*[a-z0-9]+\.[a-z]{2,3}$/i", $email) ? $email : "";
	$email_user_id = email_exists($email);
	if ( !empty($email) && is_int($email_user_id) && $current_user->ID != $email_user_id ) {
		wp_die("你的E-mai地址已经被占用，如有疑问请联系管理员！<a href='javascript:history.back();'>点此返回</a>");
	}

	$nicename = esc_html( trim($_POST['nicename']) );
	$url = esc_url( trim($_POST['url']) );
	$description = esc_html( trim($_POST['description']) );

	$userdata = array('ID' => $current_user->ID);
	if ( !empty($email) ) $userdata['user_email'] = $email;
	if ( !empty($nicename) ) $userdata['display_name'] = $nicename;
	if ( !empty($url) ) $userdata['user_url'] = $url;
	if ( !empty($description) ) $userdata['description'] = $description;

	$user_id = wp_update_user( $userdata );
	if ( is_wp_error( $user_id ) ) {
		wp_die("未知错误，更改失败！<a href='javascript:history.back();'>点此返回</a>");
	} else {
		urlStatus(true, 1);	//更新成功
	}
}

$user_url = $current_user->get('user_url');
$login_name = $current_user->get('user_login');
$nice_name = $current_user->get('display_name');
$email = $current_user->get('user_email');
$email = strpos($email, "@weibo.com") ? "" : $email;
$description = $current_user->get('description');
$author_url = get_author_posts_url( $current_user->ID );
$base_url = blueria_get_page_link('member');

get_header(); ?>

<link rel="stylesheet" href="<?php bloginfo('template_url');?>/ui/tougao.css" media="screen" />

<div class="container public"><div class="inner clearfix">

	<div class="block member_block clearfix">
		<div class="profile">
			<div class="usermeta">
				<a href="<?php echo $base_url; ?>"><em class="avatarbox"><?php echo get_avatar( $current_user->ID, '50' ); ?></em></a>
				<span class="name"><?php if ( empty($user_url) ) { echo $nice_name; } else { echo "<a href=\"{$user_url}\" target=\"_blank\">{$nice_name}</a>"; } ?></span>
			</div>
			<ul class="guide">
				<li <?php selected_class('tab', 'profile'); ?>><a href="<?php echo add_query_arg('tab', 'profile', $base_url); ?>"><i class="i-user"></i>个人资料</a></li>
				<li <?php selected_class('tab', 'favorite'); ?>><a href="<?php echo add_query_arg('tab', 'favorite', $base_url); ?>"><i class="i-heart"></i>我的收藏</a></li>
				<li <?php selected_class('tab', 'contribute'); ?>><a href="<?php echo add_query_arg('tab', 'contribute', $base_url); ?>"><i class="i-cloud-upload"></i>我的投稿</a></li>
			</ul>
		</div>
		<div class="main">
			<?php if ( isset($_GET['tab']) && 'profile' == $_GET['tab'] ) : ?>
				<div class="title">个人资料</div>
				<form method="post" action="">
					<?php if (@$_REQUEST['success'] == '1') : ?>
						<div class="Success">你的个人资料已更新！</div>
					<?php endif; ?>
					<div class="inside">
						<label for="name">用户名</label>
						<input type="text" name="name" id="name" value="<?php echo $login_name; ?>" disabled />
					</div>
					<div class="inside">
						<label for="nicename">昵称</label>
						<input type="text" name="nicename" id="nicename" value="<?php echo $nice_name; ?>" />
					</div>
					<div class="inside">
						<label for="email">E-mail</label>
						<input type="text" name="email" id="email" value="<?php echo $email; ?>" />
					</div>
					<div class="inside">
						<label for="url">个人主页</label>
						<input type="text" name="url" id="url" value="<?php echo $user_url; ?>" />
					</div>
					<div class="inside">
						<label for="description">个人签名</label>
						<textarea name="description" id="description" rows="3"><?php echo $description; ?></textarea>
					</div>
					<div class="submitbox">
						<?php wp_nonce_field('blueria', 'blueria_nonce', false); ?>
						<button type="submit" class="submit"><i class="i-check-circle"></i>更新资料</button>
					</div>
				</form>
			<?php elseif ( isset($_GET['tab']) && 'favorite' == $_GET['tab'] ) : ?>
				<div class="title">我的收藏</div>
				<?php get_template_part( 'part', 'favorite' ); ?>
			<?php elseif ( isset($_GET['tab']) && 'contribute' == $_GET['tab'] ) : ?>
				<div class="title">我的投稿</div>
				<?php get_template_part( 'part', 'contribute' ); ?>
			<?php else : ?>
				<div class="title">个人中心</div>
				<div class="share inside">
					<p>Hi，<?php echo $nice_name; ?>！如果你是本站的投稿贡献者，你可以复制下面的地址给你好友，让更多的人可以浏览你发布的内容！</p>
					<p><textarea id="author_url" data-url="<?php echo $author_url; ?>" rows="1" readonly>欢迎浏览我在 <?php bloginfo('name'); ?> 发布的内容... <?php echo $author_url; ?></textarea></p>
					<div class="bdsharebuttonbox clearfix" data-tag="blueria">
						<span>或分享到</span>
						<a title="分享到新浪微博" href="#" class="bds_tsina i-weibo" data-cmd="tsina"><i></i></a>
						<a title="分享到腾讯微博" href="#" class="bds_tqq i-tencent-weibo" data-cmd="tqq"><i></i></a>
						<a title="分享到人人网" href="#" class="bds_renren i-renren" data-cmd="renren"><i></i></a>
						<a title="分享到微信" href="#" class="bds_weixin i-wechat" data-cmd="weixin"><i></i></a>
						<a href="#" class="bds_more i-chevron-down" data-cmd="more"></a>
					</div>
				</div>
			<?php endif; ?>
		</div>
	</div>

</div></div>

<script>
	jQuery(function($){
		$("#nicename").attr("max", 20).inputlimiter();
		$("#description").attr("max", 240).inputlimiter();
		//点击全选
		$("#author_url").click(function(){
			$(this).select();
		});
		//防止回车提交
		$("form").keypress(function(e){
			if (e.keyCode == '13' && e.target.type != 'textarea') return false;	//禁止回车提交
			return true;
		});
		//表单提交验证
		$("form").submit(function(){
			var email = $.trim( $("#email").val() );
			if ( email != '' && !/^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/.test(email) ) {
				toastr['error']('E-mail格式有误');
				$("#email").focus();
				return false;
			}
		});
	});
</script>

<?php get_footer(); ?>