<?php
/*
 *	Template Name: 专题集
 */
get_header(); ?>


<div class="container public"><div class="inner clearfix">

	<div class="post_main left"><div class="post_main_wrap">
		<div class="block terms_block clearfix">
			<div class="title"><?php the_title(); ?></div>
			<div class="main topics_main">
				<?php $topics = get_terms( 'topic', array( 'hide_empty' => 0, 'orderby' => 'count', 'order' => 'DESC' ) ); ?>
				<?php if ( !empty($topics) && !is_wp_error($topics) ) : $topics_img = get_option('yeti_topics_image'); ?>
					<?php foreach ($topics as $topic) : ?>
						<?php $link = get_term_link( $topic );
							if ( $topics_img && $img_id = @$topics_img[$topic->term_id] ) {
								$src = wp_get_attachment_image_src( (int)$img_id, 'thumbnail' );
								$thumb = "<img src=\"{$src[0]}\" alt=\"{$topic->name}\" />";
							} else {
								$thumb = '<span class="thumb"></span>';
							}
						?>
						<dl class="term clearfix"><a class="clearfix" href="<?php echo $link; ?>">
							<dt><em class="thumb_wrap"><?php echo $thumb; ?></em></dt>
							<dd class="name"><?php echo $topic->name; ?></dd>
							<dd class="post_count"><?php if ($topic->count) { echo $topic->count."个话题"; } else { echo "暂无话题"; } ?></dd>
							<dd class="desc"><b>简介：</b><?php echo strip_tags($topic->description); ?></dd>
						</a></dl>
					<?php endforeach; ?>
				<?php endif; ?>
			</div>
		</div>

	</div></div>
	<?php get_sidebar(); ?>

</div></div>


<?php get_footer(); ?>