<?php
	global $current_user;
	$paged = get_query_var('paged') ? get_query_var('paged') : 1;
	$query_array = array(
		'paged' => $paged,
		'posts_per_page' => 10,
		'author' => $current_user->ID,
		'post_status' => array('publish', 'pending', 'future', 'draft'),
		'ignore_sticky_posts' => 1,
	);
	query_posts( $query_array );
	function post_status() {
		global $post;
		switch ( $post->post_status ) {
			case 'publish':
				echo "<span class='publish'>已发布</span>";
				break;
			case 'pending':
				echo "<span class='pending'>等待审核</span>";
				break;
			case 'future':
				echo "<span class='future'>即将发布</span>";
				break;
			case 'draft':
				echo "<span class='draft'>已转草稿</span>";
				break;
		}
	}
?>

<?php if ( have_posts() ) : while ( have_posts() ) : the_post(); ?>
	<?php
		$view = get_post_meta($post->ID, "views", true);
		$view = $view ? $view : 0;
		$vote_up = get_post_meta($post->ID, "blueria_vote", true);
		$vote_up = $vote_up ? $vote_up : 0;
	?>
	<dl class="post clearfix">
		<dt><a class="thumb_wrap" href="<?php the_permalink(); ?>" target="_blank"><?php the_post_thumbnail(); ?></a></dt>
		<dd class="one"><a href="<?php the_permalink(); ?>" target="_blank"><?php the_title(); ?></a><?php post_status(); ?></dd>
		<dd class="two">
			<time datetime="<?php the_time('Y-m-d'); ?>">投稿时间：<?php the_time('Y年n月j日 G时i分'); ?></time>
		</dd>
		<dd class="three">
			<span>浏览：<?php echo $view; ?></span>
			<span>赞：<?php echo $vote_up; ?></span>
			<span><?php comments_popup_link( '吐槽：0', '吐槽：1', '吐槽：%', 'comments', '吐槽：Off'); ?></span>
		</dd>
		<dd class="four">
			<?php the_tags('标签：<span>', '', '</span>'); ?>
		</dd>
	</dl>
<?php endwhile; ?>
	<div class="pagination clearfix">
		<?php echo paginate_links(array(
			'base' => str_replace( 999999999, '%#%', get_pagenum_link( 999999999 ) ),
			'format' => '',
			'total' => $wp_query->max_num_pages,
			'current' => $paged,
			'mid_size' => 3,
			'prev_text' => '上一页',
			'next_text' => '下一页'
		)); ?>
	</div>
<?php else: ?>
	<p style="font-size:14px;">你还没有发表过投稿，有什么好东西，拿出来与大家分享一下吧！</p>
<?php endif; ?>

<?php wp_reset_query(); ?>