<?php
	global $current_user;
	$ids = get_user_meta( $current_user->ID, 'like_posts', true );
	if ( empty($ids) ) {
		echo "你还没有收藏任何内容...";
		return;
	}
	$paged = get_query_var('paged') ? get_query_var('paged') : 1;
	$query_array = array(
		'paged' => $paged,
		'posts_per_page' => 10,
		'post__in' => $ids,
		'ignore_sticky_posts' => 1,
	);
	query_posts( $query_array );
?>

<?php if ( have_posts() ) : while ( have_posts() ) : the_post(); ?>
	<?php
		$view = get_post_meta($post->ID, "views", true);
		$view = $view ? $view : 0;
		$vote_up = get_post_meta($post->ID, "blueria_vote", true);
		$vote_up = $vote_up ? $vote_up : 0;
	?>
	<dl class="post clearfix">
		<dt><a class="thumb_wrap" href="<?php the_permalink(); ?>" target="_blank"><?php the_post_thumbnail(); ?></a></dt>
		<dd class="one">
			<a href="<?php the_permalink(); ?>" target="_blank"><?php the_title(); ?></a>
			<a href="javascript:;" class="like liked enabled" data-id="<?php the_ID(); ?>"><em><i class="i-times-circle-o"></i>取消收藏</em><span><i class="i-history"></i>恢复收藏</span></a>
		</dd>
		<dd class="two">
			<a href="<?php echo get_author_posts_url( get_the_author_meta('ID') ); ?>" target="_blank"><?php echo get_the_author_meta('display_name'); ?></a>
			<time datetime="<?php the_time('Y-m-d'); ?>">发表于<?php the_time('Y年n月j日 G时i分'); ?></time>
		</dd>
		<dd class="three">
			<span>浏览：<?php echo $view; ?></span>
			<span>赞：<?php echo $vote_up; ?></span>
			<span><?php comments_popup_link( '吐槽：0', '吐槽：1', '吐槽：%', 'comments', '吐槽：Off'); ?></span>
		</dd>
		<dd class="four">
			<?php the_tags('标签：<span>', '', '</span>'); ?>
		</dd>
	</dl>
<?php endwhile; ?>
	<div class="pagination clearfix">
		<?php echo paginate_links(array(
			'base' => str_replace( 999999999, '%#%', get_pagenum_link( 999999999 ) ),
			'format' => '',
			'total' => $wp_query->max_num_pages,
			'current' => $paged,
			'mid_size' => 3,
			'prev_text' => '上一页',
			'next_text' => '下一页'
		)); ?>
	</div>
<?php endif; ?>

<?php wp_reset_query(); ?>