<?php
	/**
	 *	相关文章(基于相同标签)
	 */
	$post_tags = get_the_tags();
	$tags_array = array();
	if ($post_tags) foreach ( $post_tags as $tag ) $tags_array[] = $tag->term_id;
	$query_array = array(
		'paged' => 1,
		'posts_per_page' => 8,
		'post__not_in' => array($post->ID),	//排除自身
		'tag__in' => $tags_array,
		'orderby' => 'rand',
		'category_name' => 'video,image,text',
		'ignore_sticky_posts' => 1
	);
	query_posts( $query_array );
?>

<?php if ( have_posts() ) : ?>
<div class="block related_block clearfix">
	<div class="title"><?php echo !empty($post_tags) ? '猜你喜欢' : '随机推荐'; ?></div>
	<div class="items clearfix">
		<?php while ( have_posts() ) : the_post(); ?>
			<?php
				$vote = get_post_meta($post->ID, "blueria_vote", true);
				$vote = $vote ? $vote : 0;
			?>
			<dl class="clearfix">
				<dt>
					<a class="thumb_wrap" href="<?php the_permalink(); ?>" title="浏览《<?php the_title(); ?>》" rel="nofollow"><?php the_post_thumbnail(); ?></a>
					<h3><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h3>
				</dt>
				<dd class="vote"><i class="i-thumbs-o-up"></i><?php echo $vote; ?></dd>
			</dl>
		<?php endwhile; ?>
	</div>
</div>
<?php endif; ?>

<?php wp_reset_query(); ?>