<?php 
function blueria_seo_title($title, $sep) {
	$paged = get_query_var('paged') ? get_query_var('paged') : 1;
	switch (true) {
		case is_home() :
			$desc = get_bloginfo('description');
			if ( $paged < 2 ) {
				if ( empty($desc) ) $title = get_bloginfo('name');
				else $title = get_bloginfo('name')." - ".$desc;
			} else {
				$title = get_bloginfo('name')." - 第{$paged}页";
			}
			return $title;
		case is_search() :
			$keyword = get_query_var('s');
			$title = $keyword." 的搜索结果";
			break;
		case is_category() :
			$title = trim($title)." 分类列表";
			break;
		case is_tag() :
			$title = trim($title)." 标签列表";
			break;
		case is_tax() :
			$title = trim($title)."列表";
			break;
		case is_author() :
			$title = trim($title)." 发布的文章";
			break;
		case is_archive() :
			$year = get_query_var('year');
			$monthnum = get_query_var('monthnum');
			$title = sprintf("%d年%d月的文章", $year, $monthnum);
			break;
		case is_single() :
			$title = trim($title);
			$paged = intval( get_query_var('page') );
			break;
		case is_404():
			return trim($title);
		default:
			$title = trim($title);
			break;
	}
	if ( $paged > 1 ) $title .= " 第{$paged}页";
	if ( !empty($title) ) 
		return $title." - ".get_bloginfo('name');	//&#8211;
}
add_filter('wp_title', 'blueria_seo_title', 10, 2);

function blueria_seo_meta() {
	$paged = get_query_var('paged') ? get_query_var('paged') : 1;
	if ( is_home() && $paged < 2 ) {
		$site_options = get_option('site_options', blueria_get_option('site_options'));
		$desc = strip_tags($site_options['description']);
		$words = strip_tags($site_options['keywords']);
		printf('<meta name="description" content="%s" />'."\n", $desc);
		printf('<meta name="keywords" content="%s" />'."\n", $words);
	} else if ( is_single() ) {
		if ( intval(get_query_var('page')) == 1 || intval(get_query_var('cpage')) ) {	//第一页分页与默认页重复 所有评论分页与默认页重复
			echo '<meta name="robots" content="noindex,nofollow" />'."\n";
			return;
		}

		global $post;
		$desc = !empty($post->post_excerpt) ? strip_tags($post->post_excerpt) : strip_tags( strip_shortcodes($post->post_content) );
		$desc = trim($desc);
		if ( !empty($desc) ) {
			$desc = str_replace(array("\r\n","\n","\"","\'"), " ", $desc);
			if (mb_strlen($desc) > 150) $desc = mb_substr($desc, 0, 150, 'UTF-8');
			printf('<meta name="description" content="%s" />'."\n", $desc);
		} else {
			$desc = strip_tags($post->post_title);
			printf('<meta name="description" content="%s" />'."\n", $desc);
		}

		$_sep = ',';
		$tags = get_the_term_list($post->ID, 'post_tag', '', $_sep);
		$words = $tags ? strip_tags($tags) : strip_tags($post->post_title);
		$words = str_replace(array("\"", "\'"), "", $words);
		$words = str_replace(array(" ","，"), $_sep, $words);
		if (mb_strlen($words) > 80) $words = mb_substr($words, 0, 80, 'UTF-8');
		printf('<meta name="keywords" content="%s" />'."\n", $words);
	} else if ( is_category() || is_tag() || is_tax() ) {
		$term_obj = get_queried_object();
		if ( !empty($term_obj->description) ) {
			$desc = strip_tags($term_obj->description);
			$desc = str_replace(array("\r\n","\n","\"","\'"), " ", $desc);
			$desc = trim($desc);
			if (mb_strlen($desc) > 150) $desc = mb_substr($desc, 0, 150, 'UTF-8');
			printf('<meta name="description" content="%s" />'."\n", $desc);
		}
		printf('<meta name="keywords" content="%s" />'."\n", $term_obj->name);
	}
}
add_action('wp_head', 'blueria_seo_meta', 0);