<?php
/**
 *	缩略图 接口
 *	并不是http://code.google.com/p/timthumb/ 只是用同样的文件名
 */
if ( !isset($_GET['src']) || !preg_match("#^http://#", $_GET['src']) ) {
	header('Status: 400 Bad Request');
	exit();
}

ob_start();
require_once dirname(dirname(dirname(dirname(__FILE__)))).'/wp-load.php';
include_once dirname(__FILE__).'/inc/fastimage.php';
ob_end_clean();

$cache_time = 3600 * 24;
header("Expires: ".gmdate("D, d M Y H:i:s", time() + $cache_time)." GMT");
// header("Cache-Control: public");
header("Cache-Control: max-age={$cache_time}");
header("Pragma: cache");	//HTTP1.0
header("Connection: close");


$src = trim($_GET['src']);
$w = (int)@$_GET['w'] > 10 ? (int)$_GET['w'] : 120;
$h = (int)@$_GET['h'] > 10 ? (int)$_GET['h'] : 90;

//仿盗链
$host = $_SERVER['HTTP_HOST'];
$request_from = @$_SERVER['HTTP_REFERER'];
if ( ! preg_match("#".preg_quote($host)."#", $request_from) ) {
	header("Location: {$src}");
	exit();
}


//如果是内部图片 找到或生成它的缩略图(在对应的目录)
if ( preg_match("#".preg_quote($host)."#", $src) ) {
	$file_thumb = preg_replace("/^http:.*wp-content\/uploads\/(\S*)(?:\-\d+x\d+)?\.([a-zA-Z]{3,4})$/iU", WP_CONTENT_DIR.'/uploads/$1-120x90.$2', $src);
	if ( $file_thumb != $src && !file_exists($file_thumb) ) {	//如果替换成功 并且"缩略图"不存在 按正确的缩略图路径生成一张缩略图
		$file_full  = preg_replace("/^http:.*wp-content\/uploads\/(\S*)(?:\-\d+x\d+)?\.([a-zA-Z]{3,4})$/iU", WP_CONTENT_DIR.'/uploads/$1.$2', $src);
		if ( $file_full != $src && file_exists($file_full) ) {	//如果"全尺寸图"存在
			$image = wp_get_image_editor( $file_full );
			if ( ! is_wp_error( $image ) ) {
				$image->resize( 120, 90, true );
				$image->save( $file_thumb );
			}
		} else {
			header('Status: 403 Forbidden');
			exit();
		}
	}
	header("Location: ".preg_replace("/(?:\-\d+x\d+)?\.([a-zA-Z]{3,4})$/i", '-120x90.$1', $src));	//跳转到缩略图地址
	exit();
}

//如果是站外图片
$wp_updir = wp_upload_dir();	//使用函数获取目录 原因是为了多站点的上传目录路径
$img_url_md5 = md5($src);
$possible_files = array(
	'gif' => $wp_updir['basedir'].'/yeti/'.$img_url_md5.'.gif',
	'jpg' => $wp_updir['basedir'].'/yeti/'.$img_url_md5.'.jpg',
	'png' => $wp_updir['basedir'].'/yeti/'.$img_url_md5.'.png'
);

$type = false;
foreach ($possible_files as $ext => $file) {
	if ( file_exists($file) ) {
		$type = $ext;
		break;
	}
}


if ( $type ) {	//文件已存在
	$img_name = $img_url_md5.".".$type;
} else {		//文件不存在
	$img = new FastImage($src);
	$type = false;
	$type = $img->getType();
	if ( !$type ) {
		header('Status: 403 Forbidden');
		exit();
	}
	$img_name = $img_url_md5.".".$type;
	$img_file = $wp_updir['basedir'].'/yeti/'.$img_name;
	
	$get = wp_remote_get( $src, array('timeout' => 0) );
	$img_bits = wp_remote_retrieve_body( $get );
	$mirror = wp_upload_bits($img_name, '', $img_bits, 'yeti');	//存到$wp_updir['basedir']/yeti/目录里

	$image = wp_get_image_editor( $img_file );
	if ( ! is_wp_error( $image ) ) {
		if ($type != 'gif') $image->resize( $w, $h, true );		//gif图不剪裁
		$image->save( $img_file );	//覆盖
	}
}


// 读取显示
// $type = ($type == 'jpg') ? 'jpeg' : $type;
// header("Content-Type: image/{$type}");
// echo file_get_contents($img_file);

// 直接跳转
$url = $wp_updir['baseurl']."/yeti/".$img_name;
header("Location: {$url}");
?>